/*written by: Alex Sood
debugged by: Alex Sood*/
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.InterruptedException;
import java.sql.ResultSet;
import java.sql.SQLException;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

public class LeaderBoard extends JDialog implements ActionListener
{
	public class LeaderBoardUpdater extends Thread
	{
		public LeaderBoardUpdater()
		{
			super("LeaderBoardUpdater");
			setDaemon(true);
		}
		public void run()
		{
			while(name != null)
			{
				try
				{
					ResultSet stand = AccountManager.getStandings();
					int i = 1;
					boolean found = false;
					stand.beforeFirst();
					while(stand.next())
					{
						String n = stand.getString("name");
						double v = stand.getDouble("value");
						if(i < 11) leaders[i-1].setText("" + i + "\t" + n + "\t" + v);
						if(n.equals(name))
						{
							player.setText("" + i + "\t" + n + "\t" + v);
							found = true;
						}
						if(found && i > 10) break;
						i++;
					}
				}
				catch(SQLException e) { e.printStackTrace(); }
				try
				{
					sleep(1000);
				}
				catch(InterruptedException e) { e.printStackTrace(); }
			}
		}
	}
	private JPanel dispPanel = new JPanel();
	private JPanel butPanel = new JPanel();
	private JPanel leaderPanel = new JPanel();
	private JScrollPane dispPane = new JScrollPane(leaderPanel);
	private JTextField[] leaders;
	private JTextField player = new JTextField(20);
	private JButton exit = new JButton("Exit");
	private String name;
	private LeaderBoardUpdater lbu;
	
	public LeaderBoard(String nm)
	{
		super((JFrame)(null), false);
		setTitle("LeaderBoard");
		name = nm;
		setBounds(200, 300, 350, 280);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
		getContentPane().add(dispPanel);
		getContentPane().add(butPanel);
		dispPanel.setLayout(new BoxLayout(dispPanel, BoxLayout.Y_AXIS));
		dispPanel.add(dispPane);
		dispPane.setPreferredSize(new Dimension(200, 200));
		leaderPanel.setLayout(new GridLayout(11,1,0,0));
		JTextField header = new JTextField(20);
		header.setText("Rank\tPlayer\tValue");
		header.setBackground(leaderPanel.getBackground());
		header.setFocusable(false);
		leaderPanel.add(header);
		leaders = new JTextField[10];
		for(int i = 0; i < leaders.length; i++)
		{
			leaders[i] = new JTextField(20);
			if(i % 2 >0) leaders[i].setBackground(new Color(100, 100, 255));
			leaders[i].setFocusable(false);
			leaderPanel.add(leaders[i]);
		}
		dispPanel.add(player);
		butPanel.add(exit);
		player.setFocusable(false);
		exit.addActionListener(this);
		lbu = new LeaderBoardUpdater();
		lbu.start();
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent ev)
	{
		name = null;
		dispose();
	}
}