/*written by: Alex Sood
debugged by: Alex Sood*/
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.GridLayout;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
public class LoginScreen extends JDialog implements ActionListener
{
	private JPanel inPanel = new JPanel();
	private JPanel butPanel = new JPanel();
	private JTextField nameField = new JTextField(32);
	private JTextField passField = new JTextField(32);
	private JLabel nameLabel = new JLabel("Enter account name...");
	private JLabel passLabel = new JLabel("...and password.");
	private JButton login = new JButton("Login");
	private JButton register = new JButton("Register");
	private JButton exit = new JButton("Exit");
	
	public LoginScreen()
	{
		super((JFrame)(null), false);
		setBounds(500, 500, 450, 170);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
		getContentPane().add(inPanel);
		getContentPane().add(butPanel);
		inPanel.setLayout(new GridLayout(4,1,0,0));
		inPanel.add(nameField);
		inPanel.add(nameLabel);
		inPanel.add(passField);
		inPanel.add(passLabel);
		butPanel.add(login);
		butPanel.add(register);
		butPanel.add(exit);
		login.addActionListener(this);
		register.addActionListener(this);
		exit.addActionListener(this);
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent ev)
	{
		if(ev.getSource() == login)
		{
			Portfolio p = AccountManager.login(nameField.getText(), passField.getText());
			if(p == null) return;
			new AccountScreen(p);
			dispose();
		}
		if(ev.getSource() == register)
		{
			Portfolio p = AccountManager.createAccount(nameField.getText(), passField.getText());
			if(p == null) return;
			new AccountScreen(p);
			dispose();
		}
		if(ev.getSource() == exit)
		{
			dispose();
			System.exit(0);
		}
	}
	
	public static void main(String[] args)
	{
		try
		{
			Class.forName("com.mysql.jdbc.Driver");
		}
		catch(Exception e) {e.printStackTrace(); }
		new LoginScreen();
	}
}