/*written by: Alex Sood
debugged by: Alex Sood*/
public class Order
{
	private static final double MARKET = 0.02;
	private static final double LIMIT = 0.04;
	private static final double STOPLOSS = 0.05;
	private static final double TRAILSTOP = 0.07;
	
	private String type;
	private String ticker;
	private int buyOrSell;
	private double numShares;
	private double price;
	private double percent;
	private double commission;
	private Order prev;
	private Order next;
	
	public Order(String tp, String tk, int bs, double ns, double prc, double pct)
	{
		type = tp;
		ticker = tk;
		buyOrSell = bs;
		numShares = ns;
		price = prc;
		percent = pct;
		if(type.equals("market")) commission = MARKET;
		if(type.equals("limit")) commission = LIMIT;
		if(type.equals("stoploss")) commission = STOPLOSS;
		if(type.equals("trailstop")) commission = TRAILSTOP;
	}
	
	public String getType()
	{
		return type;
	}
	
	public String getTicker()
	{
		return ticker;
	}
	
	public int getBuyOrSell()
	{
		return buyOrSell;
	}
	
	public double getNumShares()
	{
		return numShares;
	}
	
	public double getPrice()
	{
		return price;
	}
	
	public double getPercent()
	{
		return percent;
	}
	
	public double getCommission()
	{
		return commission;
	}
	
	public Order getPrev()
	{
		return prev;
	}
	
	public Order getNext()
	{
		return next;
	}
	
	public void setPrev(Order ord)
	{
		prev = ord;
	}
	
	public void setNext(Order ord)
	{
		next = ord;
	}
}