/*written by: Alex Sood
debugged by: Alex Sood*/
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;
import java.sql.SQLException;
import javax.imageio.ImageIO;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
public class StockDetailScreen extends JFrame implements ActionListener
{
	public class StockDetailPanel extends JPanel
	{
		private Image chart;
		
		public StockDetailPanel()
		{
			super();
		}
		
		protected void paintComponent(Graphics g)
		{
			if(ticker.length() == 0) return;
			try
			{
				chart = ImageIO.read(new URL("http://ichart.finance.yahoo.com/z?s=" + ticker + "&t=" + period + "&q=l&l=on&z=l&p=s&a=v&p=s").openStream());
				g.drawImage(chart, 0, 0, this);
			}
			catch(Exception e) { e.printStackTrace(); }
		}
	}
	
	private StockDetailPanel dispPanel = new StockDetailPanel();
	private JPanel inPanel = new JPanel();
	private JRadioButton oneDay = new JRadioButton("1 Day");
	private JRadioButton fiveDay = new JRadioButton("5 Day");
	private JRadioButton threeMonth = new JRadioButton("3 Month");
	private JRadioButton sixMonth = new JRadioButton("6 Month");
	private JRadioButton oneYear = new JRadioButton("1 Year");
	private JRadioButton twoYear = new JRadioButton("2 Year");
	private JRadioButton fiveYear = new JRadioButton("5 Year");
	private JTextField tickField = new JTextField(15);
	private JButton go = new JButton("GO!");
	private String ticker;
	private String period;
	
	public StockDetailScreen()
	{
		setTitle("StockDetailScreen");
		setBounds(200, 150, 850, 560);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
		getContentPane().add(dispPanel);
		getContentPane().add(inPanel);
		dispPanel.setPreferredSize(new Dimension(850, 500));
		inPanel.setLayout(new BoxLayout(inPanel, BoxLayout.X_AXIS));
		inPanel.add(oneDay);
		inPanel.add(fiveDay);
		inPanel.add(threeMonth);
		inPanel.add(sixMonth);
		inPanel.add(oneYear);
		inPanel.add(twoYear);
		inPanel.add(fiveYear);
		inPanel.add(tickField);
		inPanel.add(go);
		tickField.setMaximumSize(new Dimension(200, 20));
		ButtonGroup bg = new ButtonGroup();
		bg.add(oneDay);
		bg.add(fiveDay);
		bg.add(threeMonth);
		bg.add(sixMonth);
		bg.add(oneYear);
		bg.add(twoYear);
		bg.add(fiveYear);
		oneDay.setActionCommand("1d");
		fiveDay.setActionCommand("5d");
		threeMonth.setActionCommand("3m");
		sixMonth.setActionCommand("6m");
		oneYear.setActionCommand("1y");
		twoYear.setActionCommand("2y");
		fiveYear.setActionCommand("5y");
		oneDay.addActionListener(this);
		fiveDay.addActionListener(this);
		threeMonth.addActionListener(this);
		sixMonth.addActionListener(this);
		oneYear.addActionListener(this);
		twoYear.addActionListener(this);
		fiveYear.addActionListener(this);
		go.addActionListener(this);
		oneDay.setSelected(true);
		ticker = "";
		period = "1d";
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent ev)
	{
		if(ev.getSource() == go)
		{
			try
			{
				StockList.getPrice(tickField.getText());
				ticker = tickField.getText();
			}
			catch(SQLException e) { e.printStackTrace(); }
		}
		else period = ev.getActionCommand();
		dispPanel.repaint();
	}
}