/*written by: Alex Sood
debugged by: Alex Sood*/
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
public class OrderFiller extends Thread
{
	private Statement ment;
	
	public OrderFiller()
	{
		super("OrderFiller");
		setDaemon(true);
		try
		{
			ment = DatabaseMaintainer.getConn().createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
		}
		catch(SQLException e) { e.printStackTrace(); }
	}
	
	public void run()
	{
		while(true)
		{
			try
			{
				fillOrders();
			}
			catch(SQLException e) { e.printStackTrace(); }
			try
			{
				sleep(1000);
			}
			catch(InterruptedException e) { e.printStackTrace(); }
		}
	}
	
	private void fillOrders() throws SQLException
	{
		ResultSet orders = ment.executeQuery("select * from orders");
		orders.beforeFirst();
		while(orders.next())
		{
			String name = orders.getString("name");
			String type = orders.getString("type");
			String ticker = orders.getString("ticker");
			double amount = orders.getDouble("amount");
			int buy_sell = orders.getInt("buy_sell");
			double price = orders.getDouble("price");
			double percent = orders.getDouble("percent");
			double commission = orders.getDouble("commission");
			ResultSet priceSet = DatabaseMaintainer.getConn().createStatement().executeQuery("select price from stock_table where ticker = '" + ticker + "'");
			priceSet.first();
			double cur_price = priceSet.getDouble("price");
			if(type.equals("market") || (type.equals("limit") && buy_sell == 0 && cur_price <= price) || (type.equals("limit") && buy_sell == 1 && cur_price >= price)
				|| (type.equals("stoploss") && cur_price <= price) || (type.equals("trailstop") && (1 - cur_price/price) >= percent))
			{
				if(buy_sell == 0)
				{
					double cost = (1+commission) * amount * cur_price;
					ResultSet cashSet = DatabaseMaintainer.getConn().createStatement().executeQuery("select amount from assets where name = '" + name + "' and type = 'cash'");
					ResultSet shareSet = DatabaseMaintainer.getConn().createStatement().executeQuery("select amount from assets where name = '" + name + "' and type = '" + ticker + "'");
					cashSet.first();
					shareSet.first();
					double cash = 0;
					try
					{
						cash = cashSet.getDouble("amount");
					}
					catch(SQLException e) {}
					double shares = 0;
					try
					{
						shares = shareSet.getDouble("amount");
					}
					catch(SQLException e) {}
					if(cash < cost)
					{
					}
					else
					{
						DatabaseMaintainer.getConn().createStatement().execute("update assets set amount = " + (cash-cost) + " where name = '" + name + "' and type = 'cash'");
						if(shares == 0) DatabaseMaintainer.getConn().createStatement().execute("insert into assets values ('" + name + "', '" + ticker + "', " + amount + ", " + name + ticker + ")");
						else DatabaseMaintainer.getConn().createStatement().execute("update assets set amount = " + (shares+amount) + "where name = '" + name + "' and type = '" + ticker + "'");
					}
				}
				if(buy_sell == 1)
				{
					double income = (1-commission) * amount * cur_price;
					ResultSet cashSet = DatabaseMaintainer.getConn().createStatement().executeQuery("select amount from assets where name = '" + name + "' and type = 'cash'");
					ResultSet shareSet = DatabaseMaintainer.getConn().createStatement().executeQuery("select amount from assets where name = '" + name + "' and type = '" + ticker + "'");
					cashSet.first();
					shareSet.first();
					double cash = 0;
					try
					{
						cash = cashSet.getDouble("amount");
					}
					catch(SQLException e) {}
					double shares = 0;
					try
					{
						shares = shareSet.getDouble("amount");
					}
					catch(SQLException e) {}
					if(shares < amount)
					{
					}
					else
					{
						DatabaseMaintainer.getConn().createStatement().execute("update assets set amount = " + (cash+income) + " where name = '" + name + "' and type = 'cash'");
						DatabaseMaintainer.getConn().createStatement().execute("update assets set amount = " + (shares-amount) + "where name = '" + name + "' and type = '" + ticker + "'");
					}
				}
				DatabaseMaintainer.getConn().createStatement().execute("delete from orders where name = '" + name + "' and type = '" + type + "' and ticker = '" + ticker + "' and buy_sell = " + buy_sell + " and price = " + price + " and percent = " + percent);
			}
		}
	}
}