/*written by: Alex Sood
debugged by: Alex Sood*/
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.StringTokenizer;
public class DatabaseMaintainer extends Thread
{
    	private static final String[] list = {"A", "AA", "AA-P", "AAC", "AACC", "AAI", "AAII", "AAME", "AANB", "AAON", "AAP", "AAPL", "AAR", "AATI", "AAU", "AAUK", "AAV", "AAWW", "AAXJ", "AAZ", "AB", "ABA", "ABAT", "ABAX", "ABB", "ABBC", "ABC", "ABCB", "ABCO", "ABCW", "ABD", "ABFS", "ABG", "ABH", "ABII", "ABIO", "ABK", "ABK-PZ", "ABL", "ABM", "ABMC", "ABMD", "ABN-PE", "ABN-PF", "ABN-PG", "ABNJ", "ABR", "ABT", "ABTL", "ABV", "ABV-C", "ABVA", "ABW-PA", "ABX", "ACAD", "ACAP", "ACAS", "ACAT", "ACBA", "ACC", "ACCL", "ACE", "ACET", "ACF", "ACFC", "ACFN", "ACG", "ACGL", "ACGY", "ACH", "ACHN", "ACI", "ACIW", "ACL", "ACLI", "ACLS", "ACM", "ACMR", "ACN", "ACO", "ACOR", "ACPW", "ACS", "ACTG", "ACTI", "ACTL", "ACTS", "ACTU", "ACU", "ACUR", "ACV", "ACWI", "ACWX", "ACXM", "ACY", "ADAM", "ADAT", "ADBE", "ADC", "ADCT", "ADEP", "ADES", "ADF", "ADG", "ADGF", "ADI", "ADK", "ADK-WT", "ADL", "ADLR", "ADLS", "ADM", "ADM-PA", "ADP", "ADPI", "ADPT", "ADRA", "ADRD", "ADRE", "ADRU", "ADS", "ADSK", "ADTN", "ADVNA", "ADVNB", "ADVS", "ADX", "AE", "AEA", "AEB", "AEC", "AEC-PB", "AED", "AEE", "AEF", "AEG", "AEH", "AEHR", "AEIS", "AEL", "AEM", "AEN", "AEO", "AEP", "AEP-PA", "AEPI", "AER", "AERG", "AERO", "AERT", "AES", "AES-PC", "AET", "AETI", "AEV", "AEY", "AEZ", "AEZS", "AF", "AFAM", "AFB", "AFC", "AFCE", "AFE", "AFF", "AFFM", "AFFX", "AFFY", "AFG", "AFL", "AFN", "AFOP", "AFP", "AFSI", "AFT", "AG", "AGC", "AGD", "AGEN", "AGII", "AGL", "AGM", "AGM-A", "AGN", "AGNC", "AGO", "AGP", "AGT", "AGU", "AGX", "AGYS", "AHC", "AHCI", "AHD", "AHGP", "AHII", "AHL", "AHL-P", "AHL-PA", "AHPI", "AHR", "AHR-PC", "AHR-PD", "AHS", "AHT", "AHT-PA", "AHT-PD", "AIB", "AIG", "AIG-PA", "AIM", "AIMC", "AIN", "AINV", "AIP", "AIPC", "AIQ", "AIR", "AIRM", "AIRN", "AIRT", "AIRV", "AIS", "AIT", "AIV", "AIV-PG", "AIV-PT", "AIV-PU", "AIV-PV", "AIV-PY", "AIXG", "AIZ", "AJG", "AKAM", "AKF", "AKNS", "AKO-A", "AKO-B", "AKP", "AKR", "AKRX", "AKS", "AKT", "ALAN", "ALB", "ALC", "ALCO", "ALD", "ALDA", "ALE", "ALF", "ALG", "ALGN", "ALGT", "ALJ", "ALK", "ALKS", "ALL", "ALLB", "ALLI", "ALLT", "ALM", "ALNC", "ALNY", "ALOG", "ALOT", "ALOY", "ALP-PN", "ALP-PO", "ALP-PP", "ALQ", "ALSE", "ALSK", "ALTH", "ALTI", "ALTR", "ALTU", "ALU", "ALUS", "ALUSU", "ALUSW", "ALV", "ALVR", "ALX", "ALXA", "ALXN", "ALY", "ALZ", "AM", "AMAC", "AMAG", "AMAT", "AMB", "AMB-PL", "AMB-PM", "AMB-PO", "AMB-PP", "AMCC", "AMCE", "AMCN", "AMCS", "AMD", "AME", "AMED", "AMFI", "AMG", "AMGN", "AMIC", "AMIE", "AMIN", "AMKR", "AMLN", "AMMD", "AMN", "AMNB", "AMOT", "AMOV", "AMP", "AMPH", "AMPL", "AMR", "AMRB", "AMRI", "AMRN", "AMS", "AMSC", "AMSF", "AMSG", "AMSWA", "AMT", "AMTC", "AMTCP", "AMTD", "AMTY", "AMV", "AMV-U", "AMV-WT", "AMWD", "AMX", "AMZN", "AN", "ANAD", "ANAT", "ANCI", "ANCX", "ANDE", "ANDS", "ANEN", "ANF", "ANGN", "ANGO", "ANH", "ANH-PA", "ANH-PB", "ANIK", "ANLY", "ANN", "ANNB", "ANO", "ANPI", "ANR", "ANSS", "ANSV", "ANSW", "ANTP", "ANV", "ANW", "ANX", "AO-PA", "AOB", "AOC", "AOD", "AOG", "AOI", "AOS", "AP", "APA", "APAB", "APAC", "APAGF", "APB", "APC", "APCVZ", "APD", "APEI", "APF", "APFC", "APH", "API", "APII", "APKT", "APL", "APO", "APOG", "APOL", "APP", "APPA", "APPY", "APSA", "APSG", "APT", "APU", "APWR", "APX", "APY", "AQQ", "ARA", "ARAY", "ARB", "ARBA", "ARBX", "ARCC", "ARCI", "ARCW", "ARD", "ARDNA", "ARE", "ARE-PC", "AREX", "ARG", "ARGN", "ARH-PA", "ARH-PB", "ARIA", "ARII", "ARJ", "ARK", "ARKR", "ARL", "ARLP", "ARM", "ARMH", "ARNA", "ARO", "AROW", "ARP", "ARQL", "ARRS", "ARRY", "ARSD", "ARST", "ARTG", "ARTL", "ARTLP", "ARTNA", "ARTW", "ARTX", "ARUN", "ARW", "ARWR", "ARYX", "ASA", "ASB", "ASBC", "ASBI", "ASCA", "ASCMA", "ASEI", "ASF", "ASFI", "ASFN", "ASG", "ASGN", "ASGR", "ASH", "ASI", "ASIA", "ASMI", "ASML", "ASP", "ASPM", "ASR", "ASRV", "ASRVP", "ASTE", "ASTI", "ASTIZ", "ASTM", "ASUR", "ASX", "ASYS", "ASYT", "ATAC", "ATAI", "ATAX", "ATBC", "ATC", "ATCO", "ATE", "ATEA", "ATEC", "ATGN", "ATHN", "ATHR", "ATHX", "ATI", "ATK", "ATLO", "ATLS", "ATMI", "ATML", "ATN", "ATNI", "ATO", "ATPG", "ATR", "ATRC", "ATRI", "ATRM", "ATRO", "ATSG", "ATSI", "ATT", "ATU", "ATV", "ATVI", "ATW", "ATX", "AU", "AUBN", "AUDC", "AUO", "AUSA", "AUTH", "AUXL", "AUY", "AVA", "AVAV", "AVB", "AVCA", "AVCT", "AVD", "AVF", "AVGN", "AVID", "AVII", "AVK", "AVNR", "AVNX", "AVP", "AVRX", "AVSR", "AVT", "AVTR", "AVX", "AVY", "AVY-PA", "AVZA", "AWBC", "AWC", "AWF", "AWH", "AWI", "AWK", "AWP", "AWR", "AWRE", "AWX", "AXA", "AXAS", "AXB", "AXC", "AXC-U", "AXC-WT", "AXE", "AXG", "AXG-U", "AXG-WT", "AXK", "AXL", "AXP", "AXR", "AXS", "AXS-PA", "AXTI", "AXU", "AXYS", "AYA", "AYA-U", "AYA-WT", "AYE", "AYI", "AYN", "AYR", "AZ", "AZC", "AZK", "AZM", "AZN", "AZO", "AZZ", "B", "BA", "BAA", "BAA-WT", "BABY", "BAC", "BAC-PB", "BAC-PC", "BAC-PD", "BAC-PE", "BAC-PH", "BAC-PI", "BAC-PJ", "BAC-PL", "BAC-PU", "BAC-PV", "BAC-PW", "BAC-PX", "BAC-PY", "BAC-PZ", "BAF", "BAGL", "BAK", "BAM", "BAMM", "BANF", "BANFP", "BANR", "BAP", "BARE", "BARI", "BAS", "BASI", "BAX", "BAYN", "BBBB", "BBBY", "BBD", "BBEP", "BBF", "BBG", "BBGI", "BBI", "BBI-B", "BBK", "BBL", "BBND", "BBNK", "BBOX", "BBSI", "BBT", "BBT-PA", "BBV", "BBW", "BBX", "BBXT", "BBY", "BC", "BCA", "BCAR", "BCBP", "BCE", "BCF", "BCH", "BCK", "BCL", "BCO", "BCON", "BCPC", "BCR", "BCRX", "BCS", "BCS-P", "BCS-PA", "BCS-PC", "BCS-PD", "BCSB", "BCSI", "BCT", "BCV", "BDC", "BDCO", "BDF", "BDGE", "BDJ", "BDK", "BDL", "BDMS", "BDN", "BDN-PC", "BDN-PD", "BDR", "BDSI", "BDT", "BDV", "BDX", "BEAT", "BEAV", "BEBE", "BEC", "BECN", "BEE", "BEE-PA", "BEE-PB", "BEE-PC", "BELFA", "BELFB", "BEN", "BEO", "BEP", "BERK", "BEST", "BEXP", "BEZ", "BF-A", "BF-B", "BFBC", "BFD", "BFED", "BFIN", "BFK", "BFLY", "BFNB", "BFO", "BFR", "BFRM", "BFS", "BFS-PA", "BFS-PB", "BFSB", "BFY", "BFZ", "BG", "BGC", "BGCP", "BGE-PB", "BGF", "BGFV", "BGG", "BGH", "BGM", "BGP", "BGR", "BGS", "BGT", "BGY", "BHB", "BHD", "BHE", "BHI", "BHIP", "BHK", "BHL", "BHLB", "BHO", "BHP", "BHS", "BHV", "BHY", "BID", "BIDU", "BIDZ", "BIE", "BIF", "BIG", "BIIB", "BIO", "BIO-B", "BIOD", "BIOF", "BIOS", "BIP", "BIR-PA", "BITI", "BITS", "BJ", "BJGP", "BJRI", "BJS", "BJZ", "BK", "BK-PE", "BK-PF", "BKBK", "BKC", "BKCC", "BKD", "BKE", "BKH", "BKHM", "BKI", "BKJ", "BKK", "BKMU", "BKN", "BKOR", "BKR", "BKRS", "BKS", "BKSC", "BKT", "BKUNA", "BKYF", "BLC", "BLD", "BLDP", "BLDR", "BLE", "BLH", "BLJ", "BLK", "BLKB", "BLL", "BLSW", "BLT", "BLTI", "BLU", "BLUD", "BLW", "BLX", "BMA", "BMC", "BME", "BMI", "BMJ", "BML-PG", "BML-PH", "BML-PI", "BML-PJ", "BML-PL", "BML-PN", "BML-PO", "BML-PQ", "BMO", "BMR", "BMR-PA", "BMRC", "BMRN", "BMS", "BMT", "BMTC", "BMTI", "BMY", "BMY-P", "BNA", "BNCL", "BNCN", "BNE", "BNHN", "BNHNA", "BNI", "BNJ", "BNS", "BNSO", "BNV", "BNVI", "BNX", "BNY", "BOBE", "BOCH", "BOE", "BOFI", "BOFL", "BOH", "BOKF", "BOLT", "BOMK", "BONT", "BOOM", "BOOT", "BORL", "BOSC", "BOVA", "BP", "BPAX", "BPFH", "BPHX", "BPK", "BPL", "BPO", "BPOP", "BPOPM", "BPOPN", "BPOPO", "BPOPP", "BPP", "BPS", "BPSG", "BPT", "BPUR", "BPW", "BPW-U", "BPW-WT", "BPZ", "BQH", "BQI", "BQI-WT", "BQR", "BQY", "BR", "BRC", "BRCD", "BRCM", "BRE", "BRE-PC", "BRE-PD", "BRID", "BRK-A", "BRK-B", "BRKL", "BRKR", "BRKS", "BRLI", "BRN", "BRNC", "BRO", "BRP", "BRS", "BRS-P", "BRT", "BRY", "BSC-PX", "BSD", "BSDM", "BSE", "BSET", "BSI", "BSMD", "BSP", "BSQR", "BSRR", "BSTC", "BSX", "BSY", "BT", "BTA", "BTC", "BTC-U", "BTC-WT", "BTE", "BTF", "BTFG", "BTH", "BTI", "BTM", "BTN", "BTO", "BTU", "BTUI", "BTZ", "BUCY", "BUS", "BUS-U", "BUS-WT", "BUSE", "BVF", "BVN", "BVSN", "BVX", "BW", "BWA", "BWC", "BWF", "BWINA", "BWINB", "BWL-A", "BWLD", "BWP", "BWS", "BWTR", "BWY", "BX", "BXC", "BXG", "BXP", "BXS", "BXS-PA", "BYD", "BYFC", "BYI", "BYM", "BZ", "BZ-WT", "BZA", "BZC", "BZH", "BZM", "C", "C-PE", "C-PF", "C-PG", "C-PI", "C-PM", "C-PO", "C-PP", "C-PQ", "C-PR", "C-PS", "C-PU", "C-PV", "C-PW", "C-PZ", "CA", "CAAS", "CAB", "CABL", "CABLU", "CABLW", "CAC", "CACA", "CACAU", "CACAW", "CACB", "CACC", "CACH", "CADE", "CADX", "CAE", "CAEI", "CAF", "CAFI", "CAG", "CAH", "CAI", "CAJ", "CAKE", "CAL", "CALC", "CALD", "CALL", "CALM", "CALP", "CALPW", "CAM", "CAMD", "CAMP", "CAMT", "CAP", "CAPE", "CAPS", "CAR", "CART", "CARV", "CAS", "CASA", "CASB", "CASH", "CASM", "CASS", "CAST", "CASY", "CAT", "CATM", "CATT", "CATY", "CAV", "CAVM", "CAW", "CB", "CBAK", "CBAN", "CBB", "CBB-PB", "CBBO", "CBC", "CBC-PA", "CBC-PB", "CBD", "CBE", "CBEY", "CBG", "CBI", "CBIN", "CBK", "CBKN", "CBL", "CBL-PC", "CBL-PD", "CBLI", "CBM", "CBMX", "CBNJ", "CBNK", "CBON", "CBOU", "CBR", "CBRL", "CBRX", "CBS", "CBS-A", "CBSH", "CBST", "CBT", "CBTE", "CBU", "CBY", "CBZ", "CCA", "CCBD", "CCBG", "CCBP", "CCC", "CCE", "CCF", "CCH", "CCI", "CCIX", "CCJ", "CCK", "CCL", "CCMP", "CCNE", "CCO", "CCOI", "CCPCN", "CCRN", "CCRT", "CCS", "CCT", "CCU", "CCUR", "CCW", "CCZ", "CDE", "CDI", "CDIC", "CDII", "CDNS", "CDR", "CDR-PA", "CDTI", "CDY", "CDZI", "CE", "CE-P", "CEA", "CEBK", "CEC", "CECE", "CECO", "CEDC", "CEDU", "CEE", "CEF", "CEG", "CEG-PA", "CEGE", "CEL", "CELG", "CELL", "CENT", "CENTA", "CENX", "CEO", "CEPH", "CERN", "CERS", "CET", "CETV", "CEV", "CEVA", "CF", "CFBK", "CFC-PA", "CFC-PB", "CFD", "CFFC", "CFFI", "CFFN", "CFI", "CFK", "CFL", "CFNB", "CFNL", "CFP", "CFR", "CFS", "CFSG", "CFW", "CFX", "CGA", "CGEN", "CGL-A", "CGNX", "CGO", "CGR", "CGRB", "CGT", "CGV", "CGX", "CH", "CHA", "CHB", "CHBT", "CHCI", "CHCO", "CHD", "CHDN", "CHDX", "CHE", "CHEV", "CHFC", "CHG", "CHH", "CHI", "CHIC", "CHINA", "CHIO", "CHIP", "CHK", "CHK-PD", "CHK-PE", "CHKE", "CHKP", "CHL", "CHLN", "CHMP", "CHN", "CHNR", "CHP", "CHRD", "CHRS", "CHRT", "CHRTR", "CHRW", "CHS", "CHSCP", "CHSI", "CHT", "CHTP", "CHTR", "CHTT", "CHU", "CHUX", "CHW", "CHY", "CHYR", "CI", "CIA", "CIB", "CIDM", "CIEN", "CIF", "CIG", "CIG-C", "CII", "CIIC", "CIK", "CIM", "CIMT", "CINF", "CIO", "CIO-U", "CIO-WT", "CIR", "CISG", "CIT", "CIT-PA", "CIT-PC", "CIT-PZ", "CITP", "CITZ", "CIX", "CIZN", "CJA", "CJB", "CJBK", "CJR", "CKEC", "CKH", "CKP", "CKR", "CKSW", "CKX", "CKXE", "CL", "CLA", "CLA-U", "CLA-WT", "CLB", "CLBH", "CLC", "CLCT", "CLDA", "CLDN", "CLDX", "CLF", "CLFC", "CLFD", "CLH", "CLI", "CLM", "CLMS", "CLMT", "CLNE", "CLP", "CLP-PD", "CLR", "CLRO", "CLRT", "CLS", "CLSN", "CLUB", "CLW", "CLWR", "CLWT", "CLX", "CLZR", "CM", "CMA", "CMC", "CMCO", "CMCSA", "CMCSK", "CME", "CMED", "CMFB", "CMG", "CMG-B", "CMI", "CMK", "CMKG", "CML", "CMLS", "CMN", "CMO", "CMO-PA", "CMO-PB", "CMP", "CMRG", "CMRO", "CMS", "CMS-PA", "CMS-PB", "CMSB", "CMT", "CMTL", "CMU", "CMZ", "CNA", "CNAF", "CNB", "CNB-PB", "CNBC", "CNBKA", "CNC", "CNH", "CNI", "CNIC", "CNK", "CNL", "CNLG", "CNMD", "CNO", "CNP", "CNQ", "CNQR", "CNR", "CNS", "CNSL", "CNTF", "CNTY", "CNU", "CNVR", "CNW", "CNX", "CNXT", "COA", "COBH", "COBK", "COBR", "COBZ", "COCO", "CODI", "COF", "COF-PB", "COG", "COGO", "COGT", "COH", "COHR", "COHU", "COIN", "COINZ", "COKE", "COL", "COLB", "COLM", "COMS", "COMV", "CONN", "COO", "COOL", "COOP", "COP", "COR", "CORE", "CORS", "CORT", "COSI", "COST", "COT", "COV", "COWN", "COY", "CP", "CPA", "CPB", "CPBC", "CPBK", "CPBY", "CPD", "CPE", "CPEX", "CPF", "CPHC", "CPHD", "CPII", "CPK", "CPKI", "CPL", "CPLA", "CPLP", "CPN", "CPNO", "CPO", "CPP", "CPRT", "CPRX", "CPSI", "CPSL", "CPSS", "CPST", "CPT", "CPTS", "CPV", "CPWM", "CPWR", "CPX", "CPY", "CQB", "CQP", "CR", "CRA", "CRAI", "CRAY", "CRBC", "CRC", "CRD-A", "CRD-B", "CRDC", "CRDN", "CRE", "CRED", "CREE", "CREL", "CRESW", "CRESY", "CRF", "CRFN", "CRFT", "CRGN", "CRH", "CRI", "CRIS", "CRK", "CRL", "CRM", "CRME", "CRMH", "CRMT", "CRN", "CRNT", "CROX", "CRP", "CRR", "CRRB", "CRRC", "CRS", "CRT", "CRTX", "CRUS", "CRV", "CRVL", "CRWN", "CRWS", "CRXL", "CRXX", "CRY", "CRYP", "CRZO", "CS", "CSA", "CSAR", "CSB", "CSBC", "CSBK", "CSC", "CSCD", "CSCO", "CSCX", "CSE", "CSFL", "CSGP", "CSGS", "CSH", "CSHB", "CSII", "CSIQ", "CSKI", "CSL", "CSLR", "CSNT", "CSP", "CSPI", "CSQ", "CSR", "CSS", "CSTR", "CSU", "CSUN", "CSV", "CSWC", "CSX", "CT", "CTAS", "CTB", "CTBC", "CTBI", "CTBK", "CTCH", "CTCM", "CTCT", "CTDC", "CTEL", "CTFO", "CTGX", "CTHR", "CTIB", "CTIC", "CTL", "CTO", "CTR", "CTRN", "CTRP", "CTS", "CTSH", "CTT", "CTV", "CTWS", "CTX", "CTXS", "CTZ-PA", "CTZN", "CUB", "CUBA", "CUK", "CUO", "CUR", "CUTR", "CUZ", "CUZ-PA", "CUZ-PB", "CV", "CVA", "CVB", "CVBF", "CVBK", "CVC", "CVCO", "CVCY", "CVD", "CVG", "CVGI", "CVGW", "CVH", "CVI", "CVLL", "CVLT", "CVLY", "CVM", "CVO", "CVR", "CVS", "CVTI", "CVTX", "CVU", "CVV", "CVX", "CW", "CWBC", "CWBS", "CWCO", "CWEI", "CWF", "CWLZ", "CWST", "CWT", "CWTR", "CWZ", "CX", "CXE", "CXG", "CXH", "CXM", "CXO", "CXR", "CXSP", "CXW", "CXZ", "CY", "CYAN", "CYBE", "CYBI", "CYBS", "CYBX", "CYCC", "CYCCP", "CYCL", "CYD", "CYE", "CYH", "CYMI", "CYN", "CYNO", "CYP", "CYPB", "CYT", "CYTK", "CYTR", "CYTX", "CZFC", "CZNC", "CZWI", "CZZ", "D", "DAC", "DAI", "DAIO", "DAKT", "DAL", "DAN", "DAR", "DARA", "DATA", "DAVE", "DB", "DBD", "DBLE", "DBLEP", "DBRN", "DBTK", "DCA", "DCAI", "DCAP", "DCE", "DCGN", "DCI", "DCM", "DCO", "DCOM", "DCP", "DCS", "DCT", "DCTH", "DCU", "DCW", "DD", "DD-PA", "DD-PB", "DDD", "DDE", "DDF", "DDIC", "DDMX", "DDR", "DDR-PG", "DDR-PH", "DDR-PI", "DDRX", "DDS", "DDSS", "DDT", "DDUP", "DE", "DEAR", "DECC", "DECK", "DEG", "DEI", "DEJ", "DEL", "DELL", "DENN", "DEO", "DEP", "DEPO", "DEST", "DEX", "DF", "DFG", "DFP", "DFR", "DFS", "DFT", "DFY", "DFZ", "DGAS", "DGC", "DGF", "DGICA", "DGICB", "DGII", "DGIT", "DGLY", "DGX", "DHF", "DHFT", "DHG", "DHI", "DHIL", "DHM", "DHR", "DHT", "DHX", "DHY", "DIET", "DIGA", "DII", "DIN", "DINE", "DIOD", "DIS", "DISCA", "DISCB", "DISCK", "DISH", "DISK", "DIT", "DITC", "DIVX", "DJCO", "DK", "DKC", "DKF", "DKI", "DKK", "DKL", "DKM", "DKP", "DKQ", "DKR", "DKS", "DKT", "DKW", "DKX", "DKY", "DL", "DLA", "DLB", "DLIA", "DLLR", "DLM", "DLR", "DLR-PA", "DLR-PB", "DLTR", "DLX", "DM", "DMAN", "DMC", "DMF", "DMLP", "DMND", "DMRC", "DNB", "DNBF", "DNBK", "DNDN", "DNE", "DNEX", "DNN", "DNP", "DNR", "DNY", "DO", "DOM", "DORM", "DOV", "DOVR", "DOW", "DOX", "DPD", "DPL", "DPM", "DPO", "DPS", "DPTR", "DPW", "DPZ", "DRAD", "DRAM", "DRC", "DRCO", "DRE", "DRE-PJ", "DRE-PK", "DRE-PL", "DRE-PM", "DRE-PN", "DRE-PO", "DRH", "DRI", "DRIV", "DRJ", "DRL", "DROOY", "DRP", "DRQ", "DRRX", "DRYS", "DSCM", "DSCO", "DSF", "DSGX", "DSM", "DSP", "DSP-U", "DSP-WT", "DSPG", "DST", "DSTI", "DSU", "DSUP", "DSW", "DSWL", "DSX", "DT", "DTE", "DTE-PA", "DTE-PC", "DTF", "DTG", "DTK", "DTLK", "DTPI", "DTSI", "DTT", "DTV", "DUA", "DUC", "DUCK", "DUF", "DUK", "DUSA", "DV", "DVA", "DVAX", "DVD", "DVF", "DVM", "DVN", "DVR", "DW", "DWA", "DWCH", "DWMT", "DWRI", "DWSN", "DX", "DX-PD", "DXB", "DXCM", "DXPE", "DXR", "DXYN", "DY", "DYAX", "DYII", "DYN", "DYNT", "E", "EAC", "EAD", "EAG", "EAR", "EAT", "EBAY", "EBF", "EBHI", "EBI", "EBIX", "EBR", "EBR-B", "EBS", "EBSB", "EBTC", "EBTX", "EC", "ECA", "ECBE", "ECF", "ECGI", "ECL", "ECLP", "ECOL", "ECPG", "ECTX", "ED", "ED-PA", "ED-PC", "EDAC", "EDAP", "EDCI", "EDD", "EDE", "EDE-PD", "EDEN", "EDGR", "EDGW", "EDN", "EDR", "EDU", "EDUC", "EE", "EEA", "EEFT", "EEI", "EEP", "EEQ", "EFII", "EFJI", "EFL", "EFOI", "EFR", "EFSC", "EFT", "EFUT", "EFX", "EGBN", "EGF", "EGHT", "EGI", "EGLE", "EGN", "EGO", "EGOV", "EGP", "EGT", "EGX", "EGY", "EHA", "EHB", "EHI", "EHL", "EHTH", "EIA", "EIG", "EIHI", "EIM", "EIO", "EIP", "EIV", "EIX", "EJ", "EK", "EL", "ELC", "ELGX", "ELI", "ELMG", "ELN", "ELNK", "ELON", "ELOS", "ELOY", "ELP", "ELRC", "ELRN", "ELS", "ELSE", "ELTK", "ELX", "ELY", "EMAG", "EMC", "EMCI", "EMD", "EME", "EMF", "EMI", "EMIS", "EMITF", "EMJ", "EMKR", "EML", "EMMS", "EMMSP", "EMN", "EMO", "EMQ", "EMR", "EMS", "ENA", "ENB", "ENCO", "END", "ENDO", "ENDP", "ENER", "ENG", "ENH", "ENH-PA", "ENI", "ENL", "ENMD", "ENOC", "ENP", "ENPT", "ENR", "ENS", "ENSG", "ENT", "ENTG", "ENTN", "ENTR", "ENTU", "ENWV", "ENX", "ENZ", "ENZN", "EOC", "EOD", "EOE", "EOG", "EOI", "EONC", "EOS", "EP", "EP-PC", "EPAX", "EPAY", "EPB", "EPCT", "EPD", "EPE", "EPEX", "EPEXP", "EPG", "EPHC", "EPIC", "EPIQ", "EPIX", "EPM", "EPR", "EPR-PB", "EPR-PC", "EPR-PD", "EPR-PE", "EQ", "EQIX", "EQR", "EQR-PE", "EQR-PH", "EQR-PN", "EQS", "EQT", "EQY", "ERC", "ERES", "ERF", "ERH", "ERIC", "ERIE", "ERII", "ERJ", "EROC", "ERTS", "ES", "ESA", "ESA-U", "ESA-WT", "ESBF", "ESBK", "ESC", "ESCA", "ESCC", "ESD", "ESE", "ESEA", "ESGR", "ESI", "ESIC", "ESIO", "ESL", "ESLR", "ESLT", "ESMC", "ESP", "ESRX", "ESS", "ESSA", "EST", "EST-U", "EST-WT", "ESTX", "ESV", "ESYS", "ETB", "ETC", "ETE", "ETF", "ETFC", "ETG", "ETH", "ETJ", "ETM", "ETN", "ETO", "ETP", "ETQ", "ETR", "ETRM", "ETV", "ETW", "ETWC", "ETY", "EUBK", "EURX", "EV", "EVBN", "EVBS", "EVC", "EVEP", "EVF", "EVG", "EVJ", "EVK", "EVM", "EVN", "EVO", "EVOL", "EVP", "EVR", "EVT", "EVTC", "EVV", "EVVV", "EVY", "EW", "EWBC", "EWST", "EXAC", "EXAR", "EXAS", "EXBD", "EXC", "EXEL", "EXFO", "EXG", "EXH", "EXK", "EXLP", "EXLS", "EXM", "EXP", "EXPD", "EXPE", "EXPO", "EXR", "EXTR", "EXXI", "EZCH", "EZPW", "F", "F-PA", "F-PS", "FABK", "FAC", "FACE", "FACT", "FADV", "FAF", "FALC", "FAM", "FARM", "FARO", "FAST", "FAV", "FAX", "FBC", "FBCM", "FBF-PM", "FBF-PN", "FBIZ", "FBMI", "FBMS", "FBN", "FBNC", "FBP", "FBP-PA", "FBP-PB", "FBP-PC", "FBP-PD", "FBP-PE", "FBR", "FBS-PA", "FBSI", "FBSS", "FC", "FCAL", "FCAP", "FCBC", "FCCO", "FCCY", "FCE-A", "FCE-B", "FCEL", "FCF", "FCFC", "FCFL", "FCFS", "FCH", "FCH-PA", "FCH-PC", "FCHI", "FCJ", "FCL", "FCLF", "FCM", "FCN", "FCNCA", "FCO", "FCS", "FCSX", "FCT", "FCTY", "FCVA", "FCX", "FCX-PM", "FCY", "FCZ", "FCZA", "FDEF", "FDI", "FDML", "FDO", "FDP", "FDS", "FDX", "FE", "FEED", "FEIC", "FEIM", "FELE", "FEN", "FEO", "FEP", "FEV", "FF", "FFA", "FFBC", "FFBH", "FFC", "FFCH", "FFCO", "FFD", "FFDF", "FFEX", "FFFD", "FFG", "FFH", "FFHL", "FFHS", "FFI", "FFIC", "FFIN", "FFIV", "FFKT", "FFKY", "FFNM", "FFNW", "FFSX", "FGB", "FGC", "FGE", "FGF", "FGI", "FGP", "FGXI", "FHC", "FHI", "FHN", "FHO", "FHY", "FIC", "FIF", "FIG", "FIGI", "FIGIU", "FIGIW", "FII", "FINL", "FIRE", "FIS", "FISI", "FISV", "FIT", "FITB", "FITBP", "FIX", "FIZZ", "FJA", "FKFS", "FL", "FLC", "FLDR", "FLEX", "FLIC", "FLIR", "FLL", "FLML", "FLO", "FLOW", "FLR", "FLS", "FLWS", "FLXS", "FLY", "FMAR", "FMBI", "FMC", "FMCN", "FMD", "FMER", "FMFC", "FMN", "FMO", "FMR", "FMS", "FMS-P", "FMTI", "FMX", "FMY", "FNA", "FNB", "FNBN", "FNDT", "FNET", "FNF", "FNFG", "FNLC", "FNM", "FNM-PF", "FNM-PG", "FNM-PH", "FNM-PI", "FNM-PL", "FNM-PM", "FNM-PN", "FNM-PP", "FNM-PQ", "FNM-PR", "FNM-PS", "FNM-PT", "FNSC", "FNSR", "FNV-U", "FO", "FO-PA", "FOE", "FOF", "FOH", "FOLD", "FONR", "FOOD", "FOODW", "FOODZ", "FOR", "FORD", "FORM", "FORR", "FORTY", "FOSL", "FPBI", "FPBN", "FPC-PA", "FPFC", "FPI", "FPIC", "FPL", "FPL-PC", "FPL-PF", "FPO", "FPP", "FPT", "FPTB", "FPU", "FR", "FR-PJ", "FR-PK", "FRA", "FRB", "FRBK", "FRCCO", "FRD", "FRE", "FRE-PB", "FRE-PF", "FRE-PG", "FRE-PH", "FRE-PK", "FRE-PL", "FRE-PM", "FRE-PN", "FRE-PO", "FRE-PP", "FRE-PQ", "FRE-PR", "FRE-PS", "FRE-PT", "FRE-PU", "FRE-PV", "FRE-PW", "FRE-PX", "FRE-PY", "FRE-PZ", "FRED", "FREE", "FREEW", "FREEZ", "FRG", "FRGB", "FRM", "FRME", "FRO", "FRP", "FRPT", "FRS", "FRT", "FRX", "FRZ", "FSB", "FSBI", "FSBK", "FSC", "FSCI", "FSE", "FSF", "FSFG", "FSGI", "FSI", "FSII", "FSIN", "FSLR", "FSN", "FSN-WT", "FSNM", "FSP", "FSR", "FSRV", "FSS", "FST", "FSTF", "FSTR", "FSYS", "FT", "FTB-PA", "FTB-PB", "FTB-PC", "FTBK", "FTE", "FTEK", "FTF", "FTGX", "FTI", "FTK", "FTO", "FTR", "FTWR", "FUEL", "FUJI", "FUL", "FULT", "FUN", "FUNC", "FUND", "FUQI", "FUR", "FVE", "FWF", "FWLT", "FWLTW", "FWRD", "FWV", "FXCB", "FXEN", "FXRE", "FYR", "FYR-U", "FYR-WT", "FZN", "G", "GA", "GAB", "GAB-PD", "GAB-PF", "GABC", "GAH", "GAI", "GAIA", "GAIN", "GAIT", "GAJ", "GAM", "GAM-PB", "GAN", "GAP", "GAR", "GAS", "GASS", "GAT", "GB", "GBCI", "GBE", "GBG", "GBH", "GBL", "GBM", "GBNK", "GBR", "GBX", "GCA", "GCBC", "GCF", "GCFB", "GCH", "GCI", "GCO", "GCOM", "GCS", "GCV", "GCV-PB", "GD", "GDF", "GDI", "GDL", "GDL-PA", "GDP", "GDV", "GDV-PA", "GDV-PD", "GE", "GE-PA", "GEA", "GEC", "GED", "GEE", "GEF", "GEF-B", "GEG", "GEJ", "GEL", "GENC", "GENE", "GENR", "GENT", "GENZ", "GEO", "GEOI", "GEOY", "GEP", "GER", "GERN", "GES", "GET", "GETI", "GF", "GFA", "GFED", "GFF", "GFG", "GFI", "GFIG", "GFLB", "GFN", "GFNCU", "GFNCW", "GFSI", "GFW", "GFY", "GFZ", "GG", "GG-WT", "GGA", "GGA-U", "GGA-WT", "GGAL", "GGB", "GGC", "GGG", "GGN", "GGN-PA", "GGP", "GGR", "GGT", "GGT-PB", "GHC", "GHC-U", "GHC-WT", "GHDX", "GHI", "GHL", "GHM", "GHQ", "GHQ-U", "GHQ-WT", "GIA", "GIB", "GIFI", "GIGA", "GIGM", "GIII", "GIL", "GILD", "GILT", "GIM", "GIS", "GIVN", "GIW", "GJB", "GJD", "GJE", "GJF", "GJG", "GJH", "GJI", "GJJ", "GJK", "GJL", "GJM", "GJN", "GJO", "GJP", "GJR", "GJS", "GJT", "GJV", "GJW", "GJX", "GKK", "GKK-PA", "GKM", "GKSR", "GLA", "GLA-U", "GLA-WT", "GLAD", "GLBC", "GLBL", "GLBZ", "GLDC", "GLDD", "GLF", "GLG", "GLG-U", "GLG-WT", "GLNG", "GLO", "GLOI", "GLP", "GLQ", "GLRE", "GLRP", "GLS", "GLT", "GLU", "GLUU", "GLV", "GLW", "GM", "GMA", "GMCR", "GME", "GMET", "GMK", "GMKT", "GMO", "GMR", "GMS", "GMT", "GMT-P", "GMTC", "GMTN", "GMW", "GMXR", "GMXRP", "GNA", "GNBT", "GNCMA", "GNET", "GNH", "GNI", "GNK", "GNTX", "GNV", "GNVC", "GNW", "GOF", "GOK", "GOL", "GOLD", "GOLF", "GOM", "GOOD", "GOODO", "GOODP", "GOOG", "GORX", "GPC", "GPD", "GPE-PA", "GPE-PX", "GPH", "GPH-U", "GPH-WT", "GPI", "GPIC", "GPJ", "GPK", "GPM", "GPN", "GPOR", "GPR", "GPRE", "GPRO", "GPS", "GPU", "GPW", "GPX", "GQN", "GQN-U", "GQN-WT", "GR", "GRA", "GRAN", "GRB", "GRC", "GRE", "GRF", "GRH", "GRIF", "GRM", "GRMH", "GRMN", "GRNB", "GRO", "GROW", "GRR", "GRRF", "GRS", "GRT", "GRT-PF", "GRT-PG", "GRVY", "GRX", "GRZ", "GS", "GS-PA", "GS-PB", "GS-PC", "GS-PD", "GSAT", "GSB", "GSBC", "GSH", "GSI", "GSIC", "GSIG", "GSIT", "GSK", "GSL", "GSL-U", "GSL-WT", "GSLA", "GSOL", "GSS", "GST", "GSX", "GT", "GTA", "GTCB", "GTE", "GTF", "GTI", "GTIM", "GTIV", "GTLS", "GTN", "GTN-A", "GTS", "GTSI", "GTU", "GTXI", "GTY", "GU", "GUI", "GUID", "GUL", "GULF", "GUQ", "GUT", "GUT-PA", "GV", "GVA", "GVHR", "GVP", "GWF", "GWR", "GWW", "GXDX", "GXM", "GXP", "GXP-PA", "GXP-PD", "GXP-PE", "GY", "GYA", "GYB", "GYC", "GYMB", "GYRO", "HA", "HABC", "HAE", "HAFC", "HAIN", "HAL", "HALL", "HALO", "HANS", "HAR", "HARL", "HAS", "HAST", "HAUP", "HAV", "HAVNP", "HAYN", "HAYZ", "HBA-PD", "HBA-PF", "HBA-PG", "HBA-PH", "HBA-PZ", "HBAN", "HBANP", "HBC", "HBC-P", "HBC-PA", "HBCP", "HBE", "HBHC", "HBI", "HBIO", "HBNC", "HBNK", "HBOS", "HCBK", "HCC", "HCCI", "HCD", "HCE", "HCF", "HCH", "HCII", "HCIIW", "HCKT", "HCM", "HCN", "HCN-PD", "HCN-PF", "HCN-PG", "HCP", "HCP-PE", "HCP-PF", "HCS", "HCSG", "HD", "HDB", "HDIX", "HDNG", "HDS", "HDS-U", "HDS-WT", "HDSN", "HDY", "HE", "HE-PU", "HEAT", "HEB", "HEES", "HEI", "HEI-A", "HEK", "HEK-U", "HEK-WT", "HELE", "HEOP", "HEP", "HEPH", "HERO", "HES", "HEV", "HEW", "HF", "HFBC", "HFC-PB", "HFFC", "HFWA", "HGG", "HGIC", "HGM", "HGR", "HGRD", "HGSI", "HGT", "HH", "HHGP", "HHS", "HI", "HIA", "HIA-U", "HIA-WT", "HIBB", "HIF", "HIFN", "HIFS", "HIG", "HIH", "HIHO", "HIL", "HILL", "HIMX", "HIO", "HIS", "HIST", "HIT", "HITK", "HITT", "HIW", "HIW-PB", "HIX", "HJA", "HJE", "HJG", "HJJ", "HJL", "HJN", "HJO", "HJR", "HJT", "HJV", "HK", "HKN", "HL", "HL-PB", "HL-PC", "HLCS", "HLD", "HLD-U", "HLD-WT", "HLF", "HLIT", "HLM-P", "HLND", "HLS", "HLTH", "HLX", "HLYS", "HMA", "HMC", "HME", "HMG", "HMH", "HMIN", "HMN", "HMNA", "HMNF", "HMPR", "HMR", "HMR-U", "HMR-WT", "HMSY", "HMY", "HNAB", "HNB", "HNBC", "HNI", "HNP", "HNR", "HNSN", "HNT", "HNW", "HNZ", "HNZ-P", "HOC", "HOFT", "HOG", "HOGS", "HOKU", "HOL", "HOL-U", "HOL-WT", "HOLI", "HOLL", "HOLX", "HOMB", "HOME", "HON", "HOO", "HOOK", "HOS", "HOT", "HOTT", "HOV", "HOVNP", "HP", "HPCCP", "HPF", "HPGP", "HPI", "HPJ", "HPOL", "HPQ", "HPS", "HPT", "HPT-PB", "HPT-PC", "HPY", "HQH", "HQL", "HQS", "HR", "HRAY", "HRB", "HRBN", "HRC", "HRL", "HRLY", "HRP", "HRP-PB", "HRP-PC", "HRP-PD", "HRS", "HRSH", "HRT", "HRZ", "HRZB", "HS", "HSA", "HSC", "HSF", "HSIC", "HSII", "HSKA", "HSM", "HSNI", "HSP", "HSR", "HST", "HST-PE", "HSTM", "HSTX", "HSVLY", "HSWI", "HSY", "HT", "HT-PA", "HTB", "HTBK", "HTCH", "HTCO", "HTD", "HTE", "HTGC", "HTH", "HTH-PA", "HTLD", "HTLF", "HTM", "HTN", "HTR", "HTRN", "HTS", "HTV", "HTWR", "HTX", "HTY", "HTZ", "HUB-A", "HUB-B", "HUBG", "HUGH", "HUM", "HUN", "HURC", "HURN", "HUSA", "HVT", "HVT-A", "HW", "HWAY", "HWBK", "HWCC", "HWD", "HWFG", "HWG", "HWK", "HWKN", "HX", "HXL", "HXM", "HYA", "HYB", "HYC", "HYF", "HYGS", "HYH", "HYI", "HYJ", "HYK", "HYL", "HYM", "HYP", "HYT", "HYTM", "HYV", "HYY", "HZD", "HZK", "HZO", "IAAC", "IACI", "IAE", "IAF", "IAG", "IAN", "IAN-U", "IAN-WT", "IAO", "IART", "IAX", "IBA", "IBAS", "IBB", "IBCA", "IBCP", "IBCPO", "IBI", "IBKC", "IBKR", "IBM", "IBN", "IBNK", "IBOC", "ICA", "ICAD", "ICB", "ICCC", "ICE", "ICFI", "ICGE", "ICGN", "ICH", "ICLN", "ICLR", "ICO", "ICOC", "ICOG", "ICON", "ICOP", "ICOPW", "ICS", "ICTG", "ICUI", "ICXT", "ID", "IDA", "IDC", "IDCC", "IDG", "IDI", "IDI-U", "IDI-WT", "IDIX", "IDMI", "IDN", "IDRA", "IDSA", "IDSY", "IDT", "IDT-C", "IDTI", "IDXX", "IEP", "IEP-P", "IESC", "IEX", "IF", "IFAS", "IFC", "IFC-PM", "IFEU", "IFF", "IFGL", "IFLG", "IFLO", "IFN", "IFNA", "IFON", "IFSB", "IFSIA", "IFSM", "IFX", "IG", "IGA", "IGC", "IGC-U", "IGC-WT", "IGD", "IGK", "IGLD", "IGOI", "IGOV", "IGR", "IGT", "IGTE", "IHC", "IHG", "IHO", "IHS", "IHT", "IIA", "IIC", "IID", "IIF", "IIG", "III", "IIIIU", "IIIIW", "IIIN", "IIJI", "IILG", "IIM", "IIN", "IIT", "IIVI", "IJD", "IKAN", "IKJ", "IKL", "IKM", "IKNX", "IKR", "ILB", "ILE", "ILI", "ILMN", "IM", "IMA", "IMA-PB", "IMAX", "IMC", "IMF", "IMGN", "IMKTA", "IMM", "IMMR", "IMMU", "IMN", "IMNY", "IMO", "IMOS", "IMR", "IMS", "IMT", "IMX", "IN", "INAP", "INB", "INCB", "INCY", "IND", "INDB", "INDM", "INET", "INFA", "INFI", "INFN", "INFS", "INFY", "ING", "INHX", "ININ", "INMD", "INO", "INOC", "INOD", "INPH", "INS", "INSM", "INSP", "INSU", "INSW", "INT", "INTC", "INTG", "INTT", "INTU", "INTX", "INWK", "INXI", "INXIW", "INZ", "IO", "IOC", "IOSP", "IOT", "IP", "IPAR", "IPAS", "IPB", "IPCC", "IPCM", "IPCR", "IPCS", "IPG", "IPGP", "IPHS", "IPI", "IPII", "IPL-PB", "IPL-PC", "IPSU", "IPT", "IPXL", "IQC", "IQI", "IQM", "IQN", "IQT", "IR", "IRBT", "IRC", "IRE", "IRET", "IRETP", "IRF", "IRIS", "IRIX", "IRL", "IRM", "IRR", "IRS", "IRSN", "ISBC", "ISCA", "ISF", "ISG", "ISH", "ISHG", "ISIG", "ISIL", "ISIS", "ISL", "ISLE", "ISLN", "ISM", "ISNS", "ISP", "ISPH", "ISR", "ISRG", "ISRL", "ISSC", "ISSI", "ISTA", "ISV", "ISYS", "IT", "ITC", "ITG", "ITI", "ITIC", "ITLN", "ITMN", "ITP", "ITRI", "ITRN", "ITT", "ITU", "ITW", "ITWO", "IUSA", "IVA", "IVAC", "IVAN", "IVC", "IVD", "IVN", "IVVI", "IVZ", "IWA", "IX", "IXYS", "JACK", "JACO", "JADE", "JAH", "JAKK", "JAS", "JASO", "JAV", "JAVA", "JAX", "JAXB", "JAZZ", "JBHT", "JBI", "JBJ", "JBK", "JBL", "JBLU", "JBO", "JBR", "JBS", "JBSS", "JBT", "JCDA", "JCE", "JCG", "JCI", "JCI-PZ", "JCOM", "JCP", "JCS", "JCTCF", "JDAS", "JDD", "JDSU", "JEC", "JEF", "JEN", "JEQ", "JFBC", "JFBI", "JFC", "JFP", "JFR", "JGG", "JGT", "JGV", "JHI", "JHP", "JHS", "JHX", "JJSF", "JKHY", "JLA", "JLI", "JLL", "JMBA", "JMBAU", "JMBAW", "JMP", "JNJ", "JNPR", "JNS", "JNY", "JOB", "JOBS", "JOE", "JOEZ", "JOF", "JOSB", "JOUT", "JOYG", "JPC", "JPG", "JPM", "JPM-PE", "JPM-PF", "JPM-PG", "JPM-PI", "JPM-PJ", "JPM-PK", "JPM-PP", "JPM-PS", "JPM-PW", "JPM-PX", "JPM-PY", "JPM-PZ", "JPS", "JPZ", "JQC", "JRCC", "JRJC", "JRN", "JRO", "JRS", "JRT", "JSDA", "JSM", "JSN", "JST", "JTA", "JTD", "JTP", "JTX", "JVA", "JW-A", "JW-B", "JWF", "JWN", "JXSB", "JZC", "JZE", "JZH", "JZJ", "JZK", "JZL", "JZS", "JZT", "JZV", "K", "KAD", "KAI", "KALU", "KAMN", "KAZ", "KB", "KBALB", "KBH", "KBR", "KBW", "KBX", "KCAP", "KCC", "KCI", "KCLI", "KCP", "KCT", "KCW", "KDE", "KDN", "KED", "KEF", "KEG", "KEI", "KELYA", "KELYB", "KENT", "KEP", "KEQU", "KERX", "KEX", "KEY", "KEY-PA", "KEY-PB", "KEY-PD", "KEY-PE", "KEY-PF", "KEY-PG", "KEYN", "KF", "KFED", "KFFB", "KFN", "KFRC", "KFS", "KFT", "KFY", "KG", "KGC", "KGN", "KGS", "KHA", "KHA-U", "KHA-WT", "KHD", "KHI", "KIM", "KIM-PF", "KIM-PG", "KIRK", "KKD", "KLAC", "KLIC", "KMB", "KMGB", "KMM", "KMP", "KMR", "KMT", "KMX", "KND", "KNDI", "KNDL", "KNL", "KNM", "KNO", "KNOL", "KNOT", "KNR", "KNSY", "KNX", "KNXA", "KO", "KOB", "KOF", "KOG", "KONA", "KONG", "KOOL", "KOP", "KOPN", "KOS", "KOSS", "KOW", "KPPC", "KPPCW", "KR", "KRB-PD", "KRB-PE", "KRC", "KRC-PE", "KRC-PF", "KRG", "KRH", "KRJ", "KRNY", "KRO", "KRSL", "KRU", "KRY", "KSA", "KSK", "KSM", "KSP", "KSS", "KST", "KSU", "KSU-P", "KSW", "KSWS", "KTC", "KTCC", "KTEC", "KTF", "KTH", "KTII", "KTN", "KTOS", "KTP", "KTV", "KTX", "KUB", "KUN", "KV-A", "KV-B", "KVF", "KVHI", "KVJ", "KVM", "KVN", "KVR", "KVT", "KVU", "KVW", "KWK", "KWR", "KYE", "KYN", "KYO", "L", "LAB", "LABC", "LABL", "LACO", "LAD", "LAKE", "LAMR", "LANC", "LAQ", "LARK", "LAVA", "LAWS", "LAYN", "LAZ", "LB", "LBAI", "LBCP", "LBF", "LBIX", "LBTYA", "LBTYB", "LBTYK", "LBY", "LCAPA", "LCAPB", "LCAV", "LCC", "LCI", "LCM", "LCRD", "LCRY", "LCUT", "LDF", "LDIS", "LDK", "LDL", "LDR", "LDSH", "LEA", "LEAP", "LECO", "LEDR", "LEE", "LEG", "LEGC", "LEI", "LEN", "LEN-B", "LEO", "LF", "LFC", "LFL", "LFT", "LFUS", "LG", "LGBT", "LGCY", "LGF", "LGI", "LGL", "LGN", "LGND", "LGTY", "LGVN", "LH", "LHCG", "LHO", "LHO-PB", "LHO-PD", "LHO-PE", "LHO-PG", "LIA", "LIA-U", "LIA-WT", "LIFE", "LIHR", "LII", "LIMC", "LIME", "LIMS", "LINC", "LINE", "LINTA", "LINTB", "LION", "LIOX", "LIVE", "LIZ", "LJPC", "LKFN", "LKI", "LKQX", "LL", "LLL", "LLNW", "LLTC", "LLY", "LM", "LMAT", "LMC", "LMDIA", "LMDIB", "LMI", "LMIA", "LMLP", "LMNX", "LMT", "LNBB", "LNC", "LNC-P", "LNC-PF", "LNC-PG", "LNCE", "LNCR", "LNDC", "LNDU", "LNET", "LNG", "LNN", "LNT", "LNUX", "LNY", "LO", "LOAN", "LOCM", "LOGC", "LOGI", "LOJN", "LONG", "LOOK", "LOOP", "LOPE", "LOR", "LORL", "LOV", "LOW", "LPHI", "LPL", "LPNT", "LPS", "LPSB", "LPSN", "LPTH", "LPX", "LQDT", "LRCX", "LRN", "LRT", "LRY", "LSBI", "LSBK", "LSBX", "LSCC", "LSE", "LSE-PA", "LSI", "LSTR", "LTC", "LTC-PE", "LTC-PF", "LTD", "LTM", "LTON", "LTRE", "LTRX", "LTS", "LTXC", "LUB", "LUFK", "LUK", "LULU", "LUNA", "LUV", "LUX", "LVB", "LVLT", "LVS", "LVWR", "LWAY", "LWSN", "LXK", "LXP", "LXP-PB", "LXP-PC", "LXP-PD", "LXRX", "LXU", "LYG", "LYTS", "LYV", "LZ", "LZB", "LZR", "M", "MA", "MAA", "MAA-PH", "MAB", "MAC", "MACC", "MACE", "MAD", "MAF", "MAG", "MAGS", "MAIL", "MAIN", "MAKO", "MALL", "MAM", "MAN", "MANH", "MANT", "MAPP", "MAR", "MARPS", "MAS", "MASI", "MAT", "MATK", "MATW", "MAV", "MAXY", "MAY", "MAYS", "MBA", "MBFI", "MBH", "MBH-U", "MBH-WT", "MBHI", "MBHIP", "MBI", "MBLX", "MBND", "MBR", "MBRG", "MBRK", "MBRX", "MBT", "MBTF", "MBVT", "MBWM", "MCA", "MCBC", "MCBF", "MCBI", "MCCC", "MCD", "MCF", "MCGC", "MCHP", "MCHX", "MCI", "MCK", "MCN", "MCO", "MCR", "MCRI", "MCRL", "MCRS", "MCS", "MCY", "MCZ", "MD", "MDAS", "MDC", "MDCA", "MDCI", "MDCO", "MDF", "MDH", "MDLK", "MDM", "MDNU", "MDP", "MDQ", "MDR", "MDRX", "MDS", "MDT", "MDTH", "MDTL", "MDU", "MDVN", "MDW", "MDZ", "ME", "MEA", "MEAD", "MEAS", "MED", "MEDQ", "MEDW", "MEDX", "MEE", "MEG", "MEI", "MEJ", "MEJ-U", "MEJ-WT", "MELA", "MELI", "MEMS", "MEN", "MEND", "MENT", "MEOH", "MER-PD", "MER-PE", "MER-PF", "MER-PK", "MER-PM", "MER-PP", "MERC", "MERR", "MERX", "MESA", "MET", "MET-PA", "MET-PB", "MF", "MFA", "MFA-PA", "MFB", "MFC", "MFD", "MFE", "MFG", "MFI", "MFL", "MFLR", "MFLX", "MFM", "MFN", "MFNC", "MFRI", "MFSF", "MFT", "MFV", "MFW", "MGA", "MGAM", "MGB", "MGEE", "MGF", "MGG", "MGH", "MGI", "MGIC", "MGLN", "MGM", "MGN", "MGPI", "MGRC", "MGRM", "MGS", "MGT", "MGU", "MGYR", "MHD", "MHE", "MHF", "MHGC", "MHH", "MHI", "MHJ", "MHK", "MHLD", "MHN", "MHO", "MHO-PA", "MHP", "MHS", "MHY", "MI", "MIC", "MICC", "MIDD", "MIG", "MIGP", "MIL", "MIM", "MIN", "MIND", "MINI", "MIPI", "MIPS", "MIR", "MITI", "MITSY", "MIVA", "MIW", "MIY", "MJF", "MJH", "MJI", "MJN", "MJT", "MJV", "MJY", "MKC", "MKC-V", "MKL", "MKS", "MKSI", "MKTAY", "MKTX", "MKTY", "MKV", "MLAB", "MLG", "MLHR", "MLI", "MLM", "MLNK", "MLNX", "MLP", "MLR", "MLVF", "MMC", "MMCE", "MMG", "MMLP", "MMM", "MMP", "MMPI", "MMR", "MMR-PM", "MMS", "MMSI", "MMT", "MMU", "MMUS", "MMV", "MNDO", "MNDX", "MNE", "MNI", "MNKD", "MNNY", "MNOV", "MNP", "MNRK", "MNRO", "MNRTA", "MNRTP", "MNTA", "MNTG", "MNTX", "MO", "MOC", "MOCO", "MOD", "MOFG", "MOG-A", "MOG-B", "MOH", "MOLX", "MOLXA", "MON", "MORN", "MOS", "MOSY", "MOT", "MOV", "MOVE", "MP-PD", "MPA", "MPAA", "MPAC", "MPB", "MPEL", "MPET", "MPG", "MPG-PA", "MPJ", "MPR", "MPS", "MPV", "MPW", "MPWR", "MPX", "MQT", "MQY", "MR", "MRCY", "MRF", "MRGE", "MRH", "MRK", "MRLN", "MRM", "MRNA", "MRO", "MROE", "MRT", "MRTN", "MRVC", "MRVL", "MRX", "MS", "MS-PA", "MSA", "MSB", "MSBF", "MSCC", "MSCS", "MSD", "MSDXP", "MSEX", "MSF", "MSFG", "MSFT", "MSHL", "MSII", "MSJ", "MSK", "MSL", "MSM", "MSN", "MSNQ", "MSO", "MSON", "MSP", "MSPD", "MSPX", "MSSR", "MSTR", "MSW", "MSY", "MSZ", "MT", "MTA", "MTB", "MTB-PA", "MTD", "MTE", "MTEX", "MTG", "MTH", "MTL", "MTLK", "MTMC", "MTN", "MTNK", "MTOX", "MTP", "MTR", "MTRX", "MTS", "MTSC", "MTSI", "MTSL", "MTSM", "MTSN", "MTTT", "MTTX", "MTU", "MTW", "MTX", "MTXX", "MTZ", "MU", "MUA", "MUC", "MUE", "MUH", "MUI", "MUJ", "MUR", "MUS", "MV", "MVC", "MVF", "MVG", "MVIS", "MVISW", "MVL", "MVO", "MVSN", "MVT", "MW", "MWA", "MWE", "MWG", "MWIV", "MWO", "MWR", "MWV", "MWW", "MXA", "MXB", "MXC", "MXE", "MXE-P", "MXF", "MXGL", "MXIM", "MXM", "MXN", "MXT", "MXWL", "MYC", "MYD", "MYE", "MYF", "MYGN", "MYI", "MYJ", "MYL", "MYLNG", "MYLNP", "MYM", "MYN", "MYRG", "MZA", "MZF", "N", "NABI", "NAC", "NAD", "NADX", "NAFC", "NAI", "NAII", "NAK", "NAL", "NAN", "NANO", "NANX", "NAQ", "NAQ-U", "NAQ-WT", "NARA", "NASB", "NAT", "NATH", "NATI", "NATL", "NAV", "NAV-PD", "NAVG", "NAVI", "NAVR", "NAZ", "NBBC", "NBF", "NBG", "NBG-PA", "NBH", "NBIX", "NBJ", "NBL", "NBN", "NBO", "NBR", "NBS", "NBS-WT", "NBTB", "NBTF", "NBW", "NBXH", "NBY", "NC", "NCA", "NCBC", "NCC-PA", "NCC-PB", "NCC-PC", "NCI", "NCIT", "NCL", "NCMI", "NCO", "NCOC", "NCP", "NCR", "NCS", "NCST", "NCT", "NCT-PB", "NCT-PC", "NCT-PD", "NCTY", "NCU", "NCV", "NCX", "NCZ", "NDAQ", "NDD", "NDN", "NDSN", "NE", "NEA", "NEBS", "NECB", "NED", "NEM", "NEN", "NENG", "NEOG", "NEPT", "NETC", "NETL", "NEU", "NEWP", "NEWS", "NEWT", "NEXM", "NEXS", "NFBK", "NFC", "NFG", "NFJ", "NFL", "NFLD", "NFLX", "NFM", "NFP", "NFSB", "NFX", "NFZ", "NG", "NGA", "NGAS", "NGB", "NGBF", "NGD", "NGG", "NGK", "NGLS", "NGO", "NGPC", "NGS", "NGSX", "NGT", "NGX", "NGZ", "NHC", "NHC-PA", "NHI", "NHP", "NHP-PB", "NHR", "NHR-U", "NHR-WT", "NHS", "NHTB", "NHWK", "NI", "NICE", "NICK", "NIE", "NIF", "NIHD", "NII", "NILE", "NIM", "NINE", "NIO", "NITE", "NIV", "NJ", "NJR", "NKE", "NKG", "NKL", "NKO", "NKR", "NKSH", "NKTR", "NKX", "NL", "NLC", "NLCI", "NLP", "NLS", "NLST", "NLTX", "NLX", "NLX-U", "NLX-WT", "NLY", "NLY-PA", "NM", "NMA", "NMB", "NMD", "NMI", "NMK-PB", "NMK-PC", "NMM", "NMO", "NMP", "NMR", "NMRX", "NMT", "NMTI", "NMY", "NMZ", "NNA", "NNA-U", "NNA-WT", "NNB", "NNBR", "NNC", "NNF", "NNI", "NNJ", "NNN", "NNN-PC", "NNO", "NNP", "NNY", "NOA", "NOBH", "NOBL", "NOC", "NOEC", "NOG", "NOIZ", "NOK", "NOM", "NOOF", "NOV", "NOVA", "NOVB", "NOVL", "NOVN", "NOX", "NP", "NPBC", "NPBCO", "NPC", "NPD", "NPF", "NPG", "NPI", "NPK", "NPLA", "NPM", "NPO", "NPP", "NPSP", "NPT", "NPV", "NPX", "NPY", "NQC", "NQF", "NQI", "NQJ", "NQM", "NQN", "NQP", "NQS", "NQU", "NR", "NRB", "NRC", "NRCI", "NRF", "NRF-PA", "NRF-PB", "NRG", "NRGN", "NRGP", "NRGY", "NRIM", "NRK", "NRN", "NRO", "NRP", "NRT", "NRU", "NRVN", "NS", "NSANY", "NSC", "NSEC", "NSFC", "NSH", "NSHA", "NSIT", "NSL", "NSM", "NSPH", "NSR", "NSSC", "NST", "NSTC", "NSTR", "NSU", "NSUR", "NSYS", "NTAP", "NTC", "NTCT", "NTE", "NTES", "NTG", "NTGR", "NTIC", "NTII", "NTL", "NTLS", "NTMD", "NTN", "NTRI", "NTRS", "NTSC", "NTT", "NTWK", "NTX", "NTY", "NTZ", "NU", "NUAN", "NUC", "NUCL", "NUE", "NUF", "NUHC", "NUJ", "NUM", "NUN", "NUO", "NURO", "NUS", "NUTR", "NUV", "NUVA", "NUW", "NVAX", "NVC", "NVD", "NVDA", "NVE", "NVEC", "NVG", "NVGN", "NVJ", "NVLS", "NVMI", "NVN", "NVO", "NVR", "NVS", "NVSL", "NVTL", "NVX", "NVY", "NW-PC", "NWD", "NWE", "NWF", "NWFL", "NWI", "NWK", "NWL", "NWLI", "NWMO", "NWN", "NWPX", "NWS", "NWSA", "NWSB", "NWY", "NX", "NXC", "NXE", "NXG", "NXI", "NXJ", "NXK", "NXM", "NXN", "NXP", "NXQ", "NXR", "NXST", "NXTM", "NXXI", "NXY", "NXY-PB", "NXZ", "NYB", "NYB-PU", "NYER", "NYFX", "NYH", "NYM", "NYMT", "NYMX", "NYNY", "NYT", "NYX", "NZF", "NZH", "NZR", "NZT", "NZW", "NZX", "O", "O-PD", "O-PE", "OB", "OBAS", "OBCI", "OC", "OCCF", "OCFC", "OCLS", "OCN", "OCNF", "OCNW", "OCR", "OCR-PA", "OCR-PB", "ODC", "ODFL", "ODP", "ODSY", "OEH", "OESX", "OFC", "OFC-PG", "OFC-PH", "OFC-PJ", "OFG", "OFG-PA", "OFG-PB", "OFI", "OFIX", "OFLX", "OGE", "OGXI", "OHB", "OHI", "OHI-PD", "OI", "OIA", "OIB", "OIC", "OICO", "OII", "OIIM", "OIS", "OKE", "OKN", "OKN-U", "OKN-WT", "OKS", "OKSB", "OKSBP", "OLA", "OLBK", "OLCB", "OLN", "OLP", "OMAB", "OMC", "OMCL", "OME", "OMEX", "OMG", "OMGI", "OMI", "OMN", "OMNI", "OMPI", "OMTR", "OMX", "ONAV", "ONB", "ONB-PB", "ONCY", "ONE-PW", "ONEQ", "ONFC", "ONNN", "ONSM", "ONT", "ONTY", "ONVI", "ONXX", "OOO", "OOO-U", "OOO-WT", "OPHC", "OPK", "OPLK", "OPMR", "OPNT", "OPOF", "OPTC", "OPTR", "OPTT", "OPTV", "OPWV", "OPXA", "OPXAW", "OPXT", "OPY", "ORA", "ORB", "ORBC", "ORBK", "ORBT", "ORCC", "ORCD", "ORCH", "ORCL", "ORCT", "OREX", "ORH", "ORH-PA", "ORH-PB", "ORI", "ORIT", "ORLY", "ORNG", "ORS", "ORXE", "OSBC", "OSBCP", "OSBK", "OSCI", "OSG", "OSHC", "OSIP", "OSIR", "OSIS", "OSK", "OSM", "OSP", "OSTE", "OSTK", "OSUR", "OTE", "OTEX", "OTIV", "OTT", "OTTR", "OUTD", "OVBC", "OVLY", "OVRL", "OVTI", "OWW", "OXGN", "OXM", "OXPS", "OXY", "OYOG", "OZM", "OZRK", "PAA", "PAAS", "PABK", "PAC", "PACR", "PACW", "PAE", "PAET", "PAG", "PAGG", "PAI", "PAL", "PAL-WT", "PALM", "PANL", "PAR", "PARD", "PARL", "PAS", "PATK", "PATR", "PAX", "PAX-U", "PAX-WT", "PAY", "PAYX", "PBCI", "PBCT", "PBG", "PBH", "PBHC", "PBI", "PBI-P", "PBIB", "PBIO", "PBIP", "PBKS", "PBM", "PBNY", "PBR", "PBR-A", "PBT", "PBTQ", "PBY", "PC", "PCAP", "PCAR", "PCBC", "PCBI", "PCBK", "PCBS", "PCC", "PCCC", "PCE", "PCF", "PCG", "PCG-PA", "PCG-PB", "PCG-PC", "PCG-PD", "PCG-PE", "PCG-PG", "PCG-PH", "PCG-PI", "PCH", "PCK", "PCL", "PCLN", "PCM", "PCN", "PCP", "PCQ", "PCR", "PCS", "PCTI", "PCU", "PCX", "PCYC", "PCYO", "PCZ", "PDA", "PDC", "PDCO", "PDE", "PDEX", "PDFS", "PDGI", "PDII", "PDL-A", "PDL-B", "PDLI", "PDNT", "PDO", "PDRT", "PDS", "PDT", "PE-PA", "PE-PB", "PE-PC", "PE-PD", "PEBK", "PEBO", "PEC", "PED", "PEDH", "PEET", "PEG", "PEG-PA", "PEG-PB", "PEG-PC", "PEG-PD", "PEG-PE", "PEGA", "PEI", "PEIX", "PENN", "PENX", "PEO", "PEP", "PER", "PERF", "PERY", "PESI", "PET-PA", "PET-PB", "PET-PC", "PET-PD", "PETD", "PETM", "PETS", "PEX", "PEX-U", "PEX-WT", "PFACP", "PFBC", "PFBI", "PFBX", "PFCB", "PFD", "PFE", "PFED", "PFG", "PFG-PB", "PFH", "PFIN", "PFK", "PFL", "PFN", "PFO", "PFS", "PFSW", "PFWD", "PFX", "PG", "PGC", "PGE-PB", "PGEB", "PGH", "PGI", "PGLA", "PGLAW", "PGN", "PGNX", "PGP", "PGR", "PGTI", "PGV", "PGV-P", "PH", "PHA", "PHC", "PHD", "PHF", "PHG", "PHH", "PHHM", "PHI", "PHII", "PHIIK", "PHK", "PHM", "PHMD", "PHR", "PHT", "PHX", "PIA", "PICO", "PIF", "PII", "PIII", "PIJ", "PIM", "PINN", "PIP", "PIP-WT", "PIR", "PIS", "PIY", "PJA", "PJC", "PJE", "PJI", "PJJ", "PJL", "PJR", "PJS", "PJT", "PJZ", "PKBK", "PKD", "PKE", "PKG", "PKH", "PKI", "PKJ", "PKK", "PKM", "PKO", "PKOH", "PKOL", "PKT", "PKX", "PKY", "PKY-PD", "PL", "PL-PA", "PL-PB", "PL-PD", "PL-PS", "PLA", "PLA-A", "PLAB", "PLBC", "PLCC", "PLCE", "PLCM", "PLD", "PLD-PF", "PLD-PG", "PLFE", "PLG", "PLI", "PLJC", "PLL", "PLLL", "PLM", "PLNR", "PLPC", "PLS", "PLT", "PLUG", "PLUS", "PLV", "PLX", "PLXS", "PLXT", "PM", "PMACA", "PMB-P", "PMBC", "PMC", "PMCS", "PMD", "PMF", "PMFG", "PMI", "PMII", "PMK", "PML", "PMM", "PMNA", "PMO", "PMRY", "PMTC", "PMTI", "PMU", "PMX", "PNBC", "PNBK", "PNC", "PNC-PC", "PNC-PD", "PNC-PL", "PNCL", "PNF", "PNFP", "PNH", "PNI", "PNK", "PNM", "PNNT", "PNNW", "PNQI", "PNR", "PNRA", "PNRG", "PNS", "PNSN", "PNTR", "PNU", "PNW", "PNX", "PNXQ", "PNY", "PODD", "POH", "POL", "POM", "PONE", "POOL", "POPE", "POR", "POT", "POWI", "POWL", "POWR", "POZN", "PPBI", "PPCO", "PPD", "PPDI", "PPG", "PPHM", "PPL", "PPL-PA", "PPL-PB", "PPM", "PPO", "PPR", "PPS", "PPS-PA", "PPS-PB", "PPT", "PPW-P", "PQ", "PQBW", "PQSC", "PRA", "PRAA", "PRAN", "PRC", "PRCP", "PRD", "PRE", "PRE-PC", "PRE-PD", "PRFE", "PRFF", "PRFG", "PRFH", "PRFM", "PRFN", "PRFQ", "PRFS", "PRFT", "PRFU", "PRFZ", "PRGN", "PRGO", "PRGS", "PRGX", "PRIM", "PRIMU", "PRIMW", "PRK", "PRKR", "PRLS", "PRM", "PRO", "PROJ", "PROV", "PRPL", "PRPX", "PRS", "PRSC", "PRSP", "PRST", "PRTS", "PRU", "PRVT", "PRWT", "PRX", "PRXI", "PRXL", "PRXM", "PSA", "PSA-A", "PSA-PA", "PSA-PB", "PSA-PC", "PSA-PD", "PSA-PE", "PSA-PF", "PSA-PG", "PSA-PH", "PSA-PI", "PSA-PK", "PSA-PL", "PSA-PM", "PSA-PN", "PSA-PV", "PSA-PW", "PSA-PX", "PSA-PZ", "PSAU", "PSB", "PSB-PH", "PSB-PI", "PSB-PK", "PSB-PL", "PSB-PM", "PSB-PO", "PSB-PP", "PSBC", "PSBH", "PSDV", "PSE", "PSEC", "PSEM", "PSMT", "PSO", "PSOF", "PSS", "PSSI", "PSTA", "PSTI", "PSTL", "PSUN", "PSW", "PSY", "PSYS", "PT", "PTC", "PTEC", "PTEK", "PTEN", "PTG", "PTI", "PTIE", "PTIX", "PTN", "PTNR", "PTP", "PTR", "PTRP", "PTRY", "PTSI", "PTSX", "PTV", "PTY", "PUK", "PUK-P", "PUK-PA", "PULB", "PURE", "PVA", "PVD", "PVFC", "PVG", "PVH", "PVR", "PVSA", "PVSW", "PVTB", "PVTBP", "PVX", "PW", "PWAV", "PWE", "PWER", "PWND", "PWOD", "PWR", "PWRD", "PWX", "PX", "PXD", "PXG", "PXLW", "PXP", "PXSL", "PYA", "PYB", "PYC", "PYE", "PYG", "PYI", "PYJ", "PYK", "PYL", "PYN", "PYO", "PYS", "PYT", "PYV", "PYY", "PZB", "PZC", "PZE", "PZG", "PZN", "PZZ", "PZZA", "PZZI", "Q", "QADI", "QBAK", "QBC", "QCC", "QCCO", "QCLN", "QCOM", "QCOR", "QCRH", "QDEL", "QDHC", "QELP", "QEPC", "QGEN", "QGLY", "QGP", "QLGC", "QLTI", "QLTY", "QMM", "QPSA", "QQEW", "QQQQ", "QQQX", "QQXT", "QRCP", "QSFT", "QSII", "QSND", "QTEC", "QTM", "QTWW", "QUIK", "QUIX", "QXM", "R", "RAA", "RACK", "RAD", "RADA", "RADS", "RAE", "RAF", "RAH", "RAI", "RAIL", "RAME", "RAMR", "RAMS", "RAND", "RAP", "RAS", "RAS-PA", "RAS-PB", "RAS-PC", "RATE", "RAVN", "RAX", "RBA", "RBC", "RBCAA", "RBCN", "RBI", "RBN", "RBNF", "RBPAA", "RBS", "RBS-PF", "RBS-PH", "RBS-PL", "RBS-PM", "RBS-PN", "RBS-PP", "RBS-PQ", "RBS-PR", "RBS-PS", "RBS-PT", "RBV", "RBY", "RC", "RCC", "RCG", "RCI", "RCII", "RCKB", "RCKY", "RCL", "RCMT", "RCNI", "RCR", "RCRC", "RCS", "RDC", "RDCM", "RDEA", "RDEN", "RDI", "RDI-B", "RDK", "RDN", "RDNT", "RDR", "RDS-A", "RDS-B", "RDWR", "RDY", "RE", "RE-PB", "RECN", "REDF", "REED", "REFR", "REG", "REG-PC", "REG-PD", "REG-PE", "REGN", "REIS", "RELL", "RELV", "RENT", "REP", "REP-PA", "RES", "REV", "REVU", "REXI", "REXX", "RF", "RF-PZ", "RFA", "RFI", "RFIL", "RFMD", "RFMI", "RFO-PA", "RFR", "RGA", "RGA-PA", "RGC", "RGCI", "RGCO", "RGDX", "RGEN", "RGLD", "RGM", "RGN", "RGNC", "RGR", "RGS", "RHB", "RHI", "RHIE", "RHR", "RHT", "RIC", "RICK", "RIG", "RIGL", "RIMG", "RIMM", "RIO", "RIO-P", "RIT", "RITT", "RIV", "RIVR", "RJET", "RJF", "RKT", "RL", "RLF", "RLH", "RLH-PA", "RLI", "RLOG", "RLRN", "RMBS", "RMCF", "RMD", "RMG", "RMIX", "RMKR", "RMR", "RMT", "RMT-PA", "RMTI", "RMTR", "RMX", "RNE", "RNIN", "RNJ", "RNN", "RNO", "RNOW", "RNP", "RNR", "RNR-PB", "RNR-PC", "RNR-PD", "RNST", "RNT", "RNT-A", "RNWK", "RNY", "ROAC", "ROC", "ROCK", "ROCM", "RODM", "ROFO", "ROG", "ROH", "ROIA", "ROIAK", "ROK", "ROL", "ROLL", "ROMA", "ROME", "ROP", "ROS", "ROSE", "ROSG", "ROST", "ROX", "ROY", "ROYL", "RPF", "RPFG", "RPI", "RPM", "RPRX", "RPT", "RQI", "RRC", "RRD", "RRGB", "RRI", "RRR", "RRST", "RS", "RSC", "RSCR", "RSG", "RSH", "RSO", "RSOL", "RSTI", "RSYS", "RT", "RTEC", "RTI", "RTIX", "RTK", "RTLX", "RTN", "RTN-WT", "RTP", "RTU", "RUBO", "RUK", "RURL", "RUS", "RUSHA", "RUSHB", "RUTH", "RVBD", "RVEP", "RVI", "RVP", "RVR", "RVSB", "RVSN", "RVT", "RVT-PB", "RWC", "RWF", "RWT", "RX", "RXII", "RY", "RYAAY", "RYL", "RYN", "RZ", "S", "SA", "SAAS", "SAB", "SABA", "SAFM", "SAFT", "SAH", "SAI", "SAIA", "SAL", "SALM", "SAM", "SAMB", "SAMBW", "SAN", "SANM", "SAP", "SAPE", "SAPX", "SASR", "SATC", "SATS", "SAVB", "SAY", "SB", "SBAC", "SBBX", "SBCF", "SBGI", "SBH", "SBI", "SBIB", "SBIBN", "SBKC", "SBLK", "SBLKW", "SBN", "SBNY", "SBP", "SBR", "SBS", "SBSA", "SBSI", "SBUX", "SBW", "SBX", "SCBT", "SCD", "SCE-PB", "SCE-PC", "SCE-PD", "SCE-PE", "SCG", "SCG-P", "SCHL", "SCHN", "SCHS", "SCHW", "SCI", "SCIL", "SCKT", "SCL", "SCL-P", "SCLD", "SCLN", "SCMF", "SCMFO", "SCMM", "SCMP", "SCMR", "SCON", "SCOR", "SCR", "SCS", "SCSC", "SCSS", "SCVL", "SCX", "SD", "SDA", "SDBT", "SDIX", "SDO-PA", "SDO-PB", "SDO-PC", "SDO-PH", "SDTH", "SDXC", "SE", "SEAC", "SEB", "SEE", "SEED", "SEH", "SEIC", "SENEA", "SENEB", "SENO", "SEP", "SEPR", "SERV", "SF", "SFD", "SFE", "SFG", "SFI", "SFI-PD", "SFI-PE", "SFI-PF", "SFI-PG", "SFI-PI", "SFL", "SFLY", "SFN", "SFNC", "SFSF", "SFST", "SFY", "SGA", "SGB", "SGC", "SGEN", "SGF", "SGIC", "SGK", "SGL", "SGMA", "SGMO", "SGMS", "SGP", "SGP-PB", "SGR", "SGRP", "SGU", "SGY", "SGZ", "SHBI", "SHEN", "SHFL", "SHG", "SHI", "SHIP", "SHIPW", "SHLD", "SHLM", "SHLO", "SHMR", "SHO", "SHO-PA", "SHOO", "SHOR", "SHPGY", "SHS", "SHW", "SHZ", "SI", "SIAL", "SID", "SIEB", "SIF", "SIFI", "SIFY", "SIG", "SIGA", "SIGI", "SIGM", "SII", "SILC", "SIM", "SIMG", "SIMO", "SINA", "SINO", "SIRF", "SIRI", "SIRO", "SIVB", "SIVBO", "SIX", "SIX-PB", "SJI", "SJM", "SJR", "SJT", "SJW", "SKH", "SKIL", "SKM", "SKS", "SKT", "SKT-PC", "SKX", "SKY", "SKYW", "SLA", "SLAB", "SLB", "SLE", "SLF", "SLG", "SLG-PC", "SLG-PD", "SLGN", "SLH", "SLI", "SLM", "SLM-PA", "SLM-PB", "SLP", "SLRY", "SLS", "SLT", "SLTC", "SLTM", "SLW", "SLXP", "SM", "SMA", "SMBC", "SMBL", "SMCG", "SMCGU", "SMCGW", "SMCI", "SMD", "SMG", "SMHG", "SMI", "SMIT", "SMLC", "SMMF", "SMMX", "SMOD", "SMP", "SMRT", "SMS", "SMSC", "SMSI", "SMTB", "SMTC", "SMTL", "SMTS", "SMTX", "SNA", "SNAK", "SNBC", "SNCI", "SNCR", "SNDA", "SNDK", "SNE", "SNEN", "SNF", "SNFCA", "SNG", "SNH", "SNHY", "SNI", "SNIC", "SNMX", "SNN", "SNP", "SNPS", "SNR", "SNS", "SNSS", "SNSTA", "SNT", "SNTA", "SNTS", "SNV", "SNWL", "SNX", "SNY", "SO", "SOA", "SOAP", "SOC", "SOC-U", "SOC-WT", "SOCB", "SOFO", "SOHU", "SOL", "SOLF", "SOLR", "SOMH", "SOMX", "SON", "SONA", "SONC", "SONE", "SONO", "SONS", "SOR", "SOR-P", "SORC", "SORL", "SOV-PB", "SOV-PC", "SPA", "SPAB", "SPAN", "SPAR", "SPCHA", "SPCHB", "SPDE", "SPEC", "SPEX", "SPF", "SPG", "SPG-PI", "SPG-PJ", "SPH", "SPIL", "SPIR", "SPLS", "SPN", "SPNC", "SPNS", "SPOR", "SPP", "SPPI", "SPPR", "SPPRO", "SPPRP", "SPR", "SPRD", "SPRO", "SPROW", "SPRT", "SPSN", "SPSS", "SPTN", "SPW", "SPWRA", "SPWRB", "SQM", "SQNM", "SR", "SRCE", "SRCL", "SRDD", "SRDX", "SRE", "SRI", "SRIB", "SRLS", "SRO", "SRQ", "SRRR", "SRSL", "SRT", "SRV", "SRX", "SRZ", "SSBI", "SSD", "SSE", "SSFN", "SSI", "SSL", "SSN", "SSP", "SSRI", "SSRX", "SSS", "SSTI", "SSW", "SSY", "SSYS", "STAA", "STAN", "STAR", "STBA", "STBC", "STBK", "STC", "STD", "STD-PA", "STD-PB", "STD-PC", "STD-PI", "STE", "STEC", "STEI", "STEL", "STEM", "STFC", "STI", "STI-PA", "STI-PZ", "STJ", "STKL", "STKR", "STL", "STL-PA", "STLD", "STLY", "STM", "STMP", "STN", "STNR", "STO", "STON", "STOSY", "STP", "STR", "STRA", "STRC", "STRL", "STRM", "STRN", "STRS", "STRT", "STRZ", "STS", "STSA", "STSI", "STST", "STT", "STU", "STV", "STX", "STXS", "STXX", "STZ", "STZ-B", "SU", "SUAI", "SUBK", "SUF", "SUFB", "SUG", "SUG-PC", "SUI", "SUMR", "SUMRW", "SUMT", "SUN", "SUNH", "SUP", "SUPG", "SUPR", "SUPX", "SUR", "SURG", "SURW", "SUS-PA", "SUSQ", "SUSS", "SUTR", "SVA", "SVBI", "SVJ", "SVLF", "SVM", "SVNT", "SVR", "SVT", "SVU", "SVVS", "SWC", "SWHC", "SWIM", "SWIR", "SWK", "SWKS", "SWM", "SWN", "SWS", "SWSI", "SWWC", "SWX", "SWX-PB", "SWY", "SWZ", "SXCI", "SXE", "SXI", "SXL", "SXT", "SY", "SYBT", "SYBTP", "SYK", "SYKE", "SYMC", "SYMM", "SYMS", "SYMX", "SYNA", "SYNL", "SYNM", "SYNO", "SYNT", "SYNX", "SYPR", "SYT", "SYUT", "SYX", "SYY", "T", "TA", "TAC", "TACT", "TAGS", "TAI", "TAIT", "TAL", "TAM", "TAMB", "TAP", "TAP-A", "TAR", "TASR", "TAST", "TATTF", "TAXI", "TAYC", "TAYCP", "TAYD", "TBAC", "TBBK", "TBH", "TBHS", "TBI", "TBL", "TBSI", "TBUS", "TBV", "TC", "TCAP", "TCB", "TCB-PA", "TCBI", "TCBK", "TCHC", "TCI", "TCK", "TCL", "TCLP", "TCM", "TCO", "TCO-PG", "TCO-PH", "TCW", "TCW-U", "TCW-WT", "TCX", "TD", "TDA", "TDBK", "TDC", "TDF", "TDG", "TDI", "TDK", "TDS", "TDS-S", "TDSC", "TDW", "TDY", "TE", "TEAM", "TEAR", "TEC", "TECD", "TECH", "TECUA", "TECUB", "TEF", "TEG", "TEI", "TEL", "TELK", "TELOZ", "TEN", "TEO", "TER", "TESO", "TESS", "TEVA", "TEX", "TF", "TFC", "TFCO", "TFIN", "TFONY", "TFSL", "TFX", "TG", "TGA", "TGAL", "TGB", "TGC", "TGE", "TGEN", "TGH", "TGI", "TGIC", "TGIS", "TGP", "TGS", "TGT", "TGX", "TGY", "TGY-U", "TGY-WT", "THC", "THFF", "THG", "THI", "THLD", "THM", "THMD", "THO", "THOR", "THQI", "THRD", "THRX", "THS", "TI", "TI-A", "TIBB", "TIBX", "TICC", "TIE", "TIER", "TIF", "TIGR", "TII", "TII-A", "TIII", "TIK", "TIN", "TINY", "TIS", "TISA", "TISI", "TITN", "TIV", "TIVO", "TIXC", "TJX", "TK", "TKC", "TKF", "TKG", "TKLC", "TKO", "TKP", "TKP-U", "TKP-WT", "TKR", "TKS", "TKTM", "TLAB", "TLB", "TLCV", "TLEO", "TLF", "TLGD", "TLI", "TLK", "TLM", "TLP", "TLR", "TLVT", "TLX", "TM", "TMB", "TMCV", "TMI", "TMI-U", "TMI-WT", "TMK", "TMK-PA", "TMM", "TMNG", "TMO", "TMP", "TMPR", "TMR", "TMRK", "TMS", "TMX", "TNB", "TNC", "TNCC", "TNDM", "TNE", "TNF", "TNF-U", "TNF-WT", "TNH", "TNK", "TNL", "TNP", "TNS", "TO", "TOD", "TOF", "TOFC", "TOH", "TOH-U", "TOH-WT", "TOL", "TOMO", "TONE", "TOO", "TOPS", "TORM", "TOT", "TOWN", "TPGI", "TPI", "TPL", "TPP", "TPTX", "TPUT", "TPUTW", "TPX", "TQNT", "TR", "TRA", "TRAC", "TRAD", "TRAK", "TRBN", "TRBR", "TRC", "TRCI", "TRCR", "TRE", "TREE", "TRF", "TRGL", "TRGT", "TRH", "TRI", "TRIB", "TRID", "TRIN", "TRIS", "TRISW", "TRK", "TRLG", "TRMA", "TRMB", "TRMD", "TRMK", "TRMS", "TRN", "TRNS", "TROW", "TRP", "TRR", "TRS", "TRST", "TRT", "TRU", "TRV", "TRW", "TRXI", "TS", "TSBK", "TSC", "TSCC", "TSCM", "TSCO", "TSEM", "TSEMG", "TSFG", "TSH", "TSI", "TSL", "TSM", "TSN", "TSO", "TSON", "TSP", "TSPT", "TSRA", "TSRI", "TSS", "TSTC", "TSTF", "TSTR", "TSTY", "TSU", "TSV", "TSYS", "TTC", "TTEC", "TTEK", "TTES", "TTF", "TTGT", "TTHI", "TTI", "TTIL", "TTM", "TTMI", "TTO", "TTPA", "TTWO", "TTY", "TTY-U", "TTY-WT", "TU", "TUC", "TUES", "TUNE", "TUP", "TUTR", "TUX", "TUX-U", "TUX-WT", "TV", "TVC", "TVE", "TVH", "TVH-U", "TVH-WT", "TVIN", "TVL", "TWB", "TWC", "TWER", "TWGP", "TWI", "TWIN", "TWLL", "TWMC", "TWN", "TWP", "TWPG", "TWTC", "TWX", "TX", "TXCC", "TXCO", "TXI", "TXIC", "TXICU", "TXICW", "TXN", "TXRH", "TXT", "TXT-PA", "TXT-PB", "TY", "TY-P", "TYC", "TYG", "TYL", "TYM", "TYN", "TYPE", "TYW", "TYY", "TZF", "TZK", "TZOO", "UA", "UACL", "UAHC", "UAM", "UAUA", "UBA", "UBB", "UBCP", "UBD", "UBET", "UBFO", "UBNK", "UBOH", "UBP", "UBP-PC", "UBP-PD", "UBS", "UBS-PD", "UBSH", "UBSI", "UCBA", "UCBH", "UCBI", "UCFC", "UCTT", "UDR", "UDR-PG", "UDRL", "UDW", "UEC", "UEIC", "UEM", "UEPS", "UFCS", "UFI", "UFPI", "UFPT", "UFS", "UG", "UGI", "UGP", "UHAL", "UHS", "UHT", "UIL", "UIS", "UL", "ULBI", "ULGX", "ULTA", "ULTI", "ULTR", "ULU", "UMBF", "UMC", "UMH", "UMPQ", "UN", "UNAM", "UNB", "UNCA", "UNF", "UNFI", "UNFY", "UNH", "UNM", "UNP", "UNS", "UNT", "UNTD", "UNTY", "UPFC", "UPG", "UPI", "UPL", "UPS", "UQM", "URBN", "URG", "URI", "URRE", "URS", "URX", "URX-U", "URX-WT", "URZ", "USA", "USAK", "USAP", "USAT", "USATP", "USB", "USB-PE", "USB-PF", "USB-PG", "USB-PH", "USB-PI", "USB-PJ", "USB-PK", "USB-PL", "USBI", "USEG", "USG", "USHS", "USLM", "USM", "USMO", "USNA", "USPH", "USTR", "USU", "UTEK", "UTF", "UTG", "UTHR", "UTI", "UTIW", "UTK", "UTL", "UTMD", "UTR", "UTSI", "UTX", "UUU", "UVE", "UVSP", "UVV", "UWBK", "UWN", "UXG", "UZG", "UZV", "V", "VAL", "VALU", "VAR", "VARI", "VASC", "VAZ", "VBF", "VBFC", "VCBI", "VCF", "VCGH", "VCI", "VCLK", "VCO", "VCP", "VCV", "VDSI", "VE", "VECO", "VEL-PE", "VELC", "VETS", "VETSU", "VETSW", "VEXP", "VFC", "VFL", "VG", "VGM", "VGR", "VGZ", "VHC", "VHI", "VIA", "VIA-B", "VIAP", "VICL", "VICR", "VIDE", "VIFL", "VIGN", "VII", "VIM", "VIMC", "VIP", "VIRC", "VIRL", "VISN", "VIST", "VIT", "VITA", "VIV", "VIVO", "VKI", "VKL", "VKQ", "VLCCF", "VLCM", "VLGEA", "VLNC", "VLO", "VLT", "VLTR", "VLY", "VLY-PA", "VLYWW", "VM", "VMC", "VMED", "VMEDW", "VMI", "VMM", "VMO", "VMV", "VMW", "VNBC", "VNDA", "VNO", "VNO-PA", "VNO-PE", "VNO-PF", "VNO-PG", "VNO-PH", "VNO-PI", "VNUS", "VNV", "VOCL", "VOCS", "VOD", "VOL", "VOLC", "VOLT", "VOQ", "VOXW", "VOXX", "VPF", "VPFG", "VPHM", "VPRT", "VPS", "VPV", "VQ", "VR", "VRAD", "VRAZ", "VRGY", "VRNM", "VRS", "VRSN", "VRTA", "VRTB", "VRTS", "VRTU", "VRTX", "VRUS", "VRX", "VRY", "VRY-U", "VRY-WT", "VSAT", "VSBN", "VSCI", "VSCP", "VSEA", "VSEC", "VSGN", "VSH", "VSNT", "VSR", "VTA", "VTAL", "VTG", "VTG-U", "VTG-WT", "VTIV", "VTJ", "VTN", "VTNC", "VTO", "VTR", "VUNC", "VVC", "VVI", "VVR", "VVTV", "VVUS", "VXC-PD", "VYFC", "VZ", "WAB", "WABC", "WACLY", "WAG", "WAIN", "WAL", "WALK", "WASH", "WAT", "WATG", "WAVE", "WAVX", "WAYN", "WB-PB", "WB-PC", "WB-PD", "WBC", "WBCO", "WBD", "WBK", "WBMD", "WBNK", "WBNKW", "WBS", "WBSN", "WBSTP", "WCAA", "WCBO", "WCC", "WCG", "WCN", "WCO", "WCRX", "WDC", "WDFC", "WDR", "WEA", "WEBM", "WEC", "WEDC", "WEL", "WEN", "WERN", "WES", "WEST", "WEX", "WEYS", "WF", "WFC", "WFC-PJ", "WFC-PL", "WFD", "WFMI", "WFR", "WFSL", "WFT", "WG", "WGA", "WGL", "WGNA", "WGNB", "WGNR", "WGO", "WGOV", "WGW", "WH", "WHG", "WHI", "WHR", "WHRT", "WHX", "WIA", "WIBC", "WILC", "WIN", "WINA", "WIND", "WINN", "WIRE", "WIS-P", "WIT", "WIW", "WL", "WLB", "WLB-P", "WLDN", "WLFC", "WLFCP", "WLK", "WLL", "WLP", "WLT", "WMAR", "WMB", "WMCO", "WMG", "WMGI", "WMI", "WMK", "WMS", "WMT", "WMZ", "WNA-P", "WNC", "WNI", "WNR", "WNS", "WOC", "WOLF", "WOOD", "WOOF", "WOR", "WPC", "WPCS", "WPI", "WPK", "WPO", "WPP", "WPPGY", "WPRT", "WPTE", "WPZ", "WR", "WRB", "WRB-PA", "WRC", "WRE", "WRES", "WRI", "WRI-PD", "WRI-PE", "WRI-PF", "WRLD", "WRLS", "WRS", "WSB", "WSBC", "WSBF", "WSC", "WSCC", "WSCI", "WSF", "WSFG", "WSFS", "WSH", "WSII", "WSM", "WSO", "WSO-B", "WST", "WSTG", "WSTL", "WSTM", "WTBA", "WTFC", "WTI", "WTM", "WTNY", "WTR", "WTS", "WTSLA", "WTT", "WTU", "WTW", "WU", "WUHN", "WVCM", "WVFC", "WVVI", "WW", "WWE", "WWVY", "WWW", "WWWW", "WX", "WXCO", "WXS", "WY", "WYE", "WYE-P", "WYN", "WYNN", "WYY", "WZE", "WZEN", "X", "XAA", "XATA", "XCJ", "XCO", "XCR", "XEC", "XEL", "XEL-PA", "XEL-PB", "XEL-PC", "XEL-PD", "XEL-PE", "XEL-PG", "XETA", "XFB", "XFD", "XFH", "XFJ", "XFL", "XFN", "XFP", "XFR", "XGM", "XIDE", "XIDEW", "XIN", "XING", "XJT", "XKE", "XKK", "XKN", "XKO", "XL", "XL-PY", "XLNX", "XNN", "XNPT", "XOM", "XOMA", "XPL", "XPO", "XPRT", "XRA", "XRAY", "XRIT", "XRM", "XRTX", "XRX", "XSEL", "XTEX", "XTLB", "XTNT", "XTO", "XTXI", "XVF", "XVG", "XXIA", "Y", "YAVY", "YDNT", "YGE", "YHOO", "YMI", "YORW", "YPF", "YRCW", "YSI", "YTEC", "YUM", "YZC", "ZANE", "ZAP", "ZB-PA", "ZB-PB", "ZB-PC", "ZBB", "ZBRA", "ZEP", "ZEUS", "ZF", "ZGEN", "ZHNE", "ZICA", "ZIGO", "ZILA", "ZILG", "ZINC", "ZION", "ZIOP", "ZIPR", "ZIXI", "ZLC", "ZMH", "ZN", "ZN-WT", "ZNH", "ZNT", "ZOLL", "ZOLT", "ZOOM", "ZQK", "ZRAN", "ZRBA", "ZTR", "ZUMZ"};
	private static final String url = "jdbc:mysql://localhost/group902?user=group902&password=RUcore09";
	private static Connection conn;

	public DatabaseMaintainer()
	{
		super("DatabaseMaintainer");
		try
		{
		    conn = DriverManager.getConnection(url);
		}
		catch(SQLException e)
		{
			e.printStackTrace();
			return;
		}
	}
	public void run()
	{
		while(true)
		{
			update();
			try
			{
				sleep(1000);
			}
			catch(Exception e)
			{
				System.out.println(e.toString());
			}
		}
	}
    public static Connection getConn()
    {
	
	return conn;
    }
    
	public void update()
	{
	    System.out.println("update()");
		if(conn == null) return;
		double price = 0;
		double change = 0;
		for(int x = 0; x < list.length; x++)
		{
			try
			{
				String s = yahooInterface(list[x]);
				StringTokenizer st = new StringTokenizer(s, ",\"");
				String tic = st.nextToken();
				price = Double.parseDouble(st.nextToken());
				st.nextToken();
				st.nextToken();
				change = Double.parseDouble(st.nextToken());
				conn.createStatement().execute("update stock_table set price = " + price + ", price_change = " + change + " where ticker = '" + tic + "'");
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
	}
	private String yahooInterface(String ticker) throws Exception
	{
		String u = "http://download.finance.yahoo.com/d/quotes.csv?s=" + ticker + "&f=sl1d1t1c1ohgv&e=.csv";
		URL l = new URL(u);
		HttpURLConnection con = (HttpURLConnection)l.openConnection();
		con.setRequestMethod("GET");
		con.setDoInput(true);
		con.setDoOutput(false);
		con.connect();
		InputStream is = con.getInputStream();
		BufferedReader br = new BufferedReader(new InputStreamReader(is));
		return br.readLine();
	}
	public static void main(String[] args)
	{
		try
		{
			Class.forName("com.mysql.jdbc.Driver");
		}
		catch(Exception e) { e.printStackTrace(); }
		DatabaseMaintainer dm = new DatabaseMaintainer();
		dm.start();
		LookOut lo = new LookOut();
		lo.start();
		LeaderBoardMaintainer lbm = new LeaderBoardMaintainer();
		lbm.start();
		OrderFiller of = new OrderFiller();
		of.start();
	}
}